// $Id$
App.RequestController = Ember.ObjectController.extend({});

App.RequestCertController = Ember.Object.create({
    req_id:"",
    status:"",
    challenge_id:"",
    mapping_id:"",
    requester: "", //No I18N
    sdomain: "",
    domain:"",
    agentid:"",
    parent :"",
    processed_by:"",
    no_of_years:"",
    notes:"",
    flag:"",
    selectedTab:"",
    requestType:"",
    newCertId:"",
    isCSR:false,
    edit:false,
    cert_type:true,
    cert_names:"",
    challengeType:"",
    dns_server:"",
    dns_id:"",
    order_id:"",
    params:"",
    fileData:"",
    browse:"",
    textfield:""
});

App.RequestListController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions : {
        showDetailsDialog:function()
        {
            var app=this.get('controllers.application');
            app.send('opendialog','RequestDetails');//NO I18N
        },
        showReqCloseDialog:function()
        {
            var app=this.get('controllers.application');
            app.send('opendialog','RequestClosed');//NO I18N
        },
        deleteRequest:function()
        {
            var grid = jQuery("#PKIRequestList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('Select at least one request')); //No I18N
                return;
        }
            vConfirmation(I18N.getMsg('letsencrypt.deleterequest.confirm'),function(){//NO I18N
                var arr = new Array();
                var req_ids="";
                $.each(selRowIds, function()
                {
                    var id = this;
                    var req_id = grid.jqGrid('getCell', id, 'REQUESTID'); //No I18N
                    if(req_ids!=="")
                    {
                        req_ids=req_ids+","+req_id;//NO I18N
                    }
                    else
                    {
                        req_ids=req_id;
                    }
                });
                var ajaxRequestUrl = '/api/pki/request/deleteRequest'; //No I18N
                var params="req_ids="+req_ids;//NO I18N
                ajaxRequestWithCookie(ajaxRequestUrl,params,false,"",true,function(jsonData){
                        if(jsonData.Status==="Success")//NO I18N
                        {
                            messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                            {{App.Request.getRequestList();}}
                        }
                        else
                        {
                            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                        }                                                        
                });
            });
        }
    }
});

App.RequestOpenController = Ember.ObjectController.extend({
    actions : {
      	requestSubmit: function()
	{
            var REQ_NAME="";
            var CERT_DOMAIN="";
            var PAR_DOMAIN="";
            var MAILID="";
            var contentData = {};
            var object = {};
            REQ_NAME = document.getElementById('request_name').value; //No I18N
            var NO_OF_YEARS=document.getElementById('NO_OF_YEARS').value;//No I18N
            var NOTES=document.getElementById('notes').value;//No I18N
            MAILID=document.getElementById('mail').value;//No I18N
            var devicename="";
            var ipaddress="";
            var params='REQ_NAME=';//NO I18N
            if(App.RequestCertController.requestType==="New_Cert_Req")
            {
                if(document.getElementById("isCSR").checked)
                {
                if(document.getElementById("CSR_TYPE").checked)
                {
                    if(document.getElementById("CNames").value=="")
                    {
                        showAlert("Select Common Name Of CSR");//No I18N
                        return;
                    }
                    params=params+"&CSR_TYPE=Select"+"&SELECTED_CSR="+document.getElementById("CNames").value;//NO I18N
                }
                else if(document.getElementById("CSR_TYPE2").checked)
                {
                    if(document.getElementById("Cert_Content").value=="")
                    {
                        showAlert("Paste the CSR Content Correctly");//No I18N
                        return;
                    }
                    params=params+"&CSR_TYPE=Content";//NO I18N
                    object.CSR_CONTENT = document.getElementById("Cert_Content").value;
                    contentData.CSRCONTENT = JSON.stringify(object);
                }
                else if(document.getElementById("CSR_TYPE3").checked)
                {
                    if(document.getElementById("filename").value=="" || window.FILE_CONTENT=="")
                    {
                        showAlert("Select the CSR File Correctly");//No I18N
                        return;
                    }
                    params=params+"&CSR_TYPE=Content";//NO I18N
                    object.CSR_CONTENT = window.FILE_CONTENT;
                    contentData.CSRCONTENT = JSON.stringify(object);
                }
                }else
                {
                    CERT_DOMAIN=document.getElementById('sdomain').value;//No I18N
                    if(CERT_DOMAIN=='')//No I18N
                    {
                       showAlert(I18N.getMsg('js.sslcertificate.enterDomainName'));//No I18N
                        return;
                    }              
                    params=params+'&CERT_DOMAIN='+CERT_DOMAIN;//NO I18N
                }
                params=params+'&REQ_TYPE=New_Domain';//NO I18N
            }
            else
            {
                CERT_DOMAIN=document.getElementById('sdomain').value;//No I18N
                PAR_DOMAIN=document.getElementById('PARENTNAME').value;//No I18N
            if(PAR_DOMAIN==='---select---')//No I18N
            {
               showAlert(I18N.getMsg('js.sslcertificate.selectParentDomain'));//No I18N
                return;
            }
            if(CERT_DOMAIN=='')//No I18N
            {
               showAlert(I18N.getMsg('js.sslcertificate.enterDomainName'));//No I18N
                return;
            }
                params=params+'&CERT_DOMAIN='+CERT_DOMAIN+'&PAR_DOMAIN='+PAR_DOMAIN+'&REQ_TYPE=Domain_Add';//No I18N 
            }
            
            if(NO_OF_YEARS==''||isNaN(NO_OF_YEARS) ||NO_OF_YEARS<=0 || NO_OF_YEARS!=parseInt(NO_OF_YEARS))//No I18N
            {
               showAlert(I18N.getMsg('js.sslcertificate.enterNumberOfYears'));//No I18N
                return;
            }
            if(!validateEmail(MAILID)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
		return;
            }
            if(document.getElementById("addAdditionalFields").checked)
            {
                devicename=$('#devNameID').val();
                ipaddress=$('#ipAddrID').val();
                params=params+'&deviceName='+devicename+'&ipaddress='+ipaddress;//NO I18N
            }
            params=params+'&MAILID='+MAILID+'&NO_OF_YEARS='+NO_OF_YEARS+'&NOTES='+NOTES; //No I18N
            var ajaxRequestUrl = '/api/pki/request/newRequest?'+params; //No I18N
            contentData.pmpcp=Get_Cookie('pmpcc');//No I18N
            getAjaxApiRequest("/api/pki/settings/getPrivacyConsent","",function(jsonData){//NO I18N
                contentData.isPrivacyEnabled=jsonData.isPrivacyEnabled;
                if(!jsonData.isPrivacyEnabled)
                {
                    vConfirmation1(I18N.getMsg("js.gdpr.certrequest.consent"),function(){//NO I18N
                        getAjaxApiRequest(ajaxRequestUrl,contentData,function(jsonData){
                            if(jsonData.Status==="Success")//NO I18N
                            {
                                messageNotification("messageNotifySuccess",I18N.getMsg("js.sslcert.request.requestAddedSuccessfully"));//No I18N
                                redirectUrl("SSLMgmt/Request/List");//NO I18N
                            }
                            else
                            {
                                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                            }                                                        
                        });
                    },I18N.getMsg("js.ack.req"),500);//NO I18N
                }
                else
                {
                    getAjaxApiRequest(ajaxRequestUrl,contentData,function(jsonData){
                            if(jsonData.Status==="Success")//NO I18N
                            {
                                messageNotification("messageNotifySuccess",I18N.getMsg("js.sslcert.request.requestAddedSuccessfully"));//No I18N
                                redirectUrl("SSLMgmt/Request/List");//NO I18N
                                }
                            else
                            {
                                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                            }                                                        
                    });
                }
            });
        }
    }
});


App.CreateFormController = Ember.ObjectController.extend({
    actions : {
        createFormSubmit: function(){
            var CNAME=$("#common_name").val().trim();
            var ORGUNIT=$("#orgunit").val().trim();
            var ORG=$("#org").val().trim();
            var LOCATION=$("#loc").val().trim();
            var STATE=$("#isstate").val().trim();
            var COUNTRY=$("#country").val().trim();
            var PASSWORD=$("#password").val().trim();
            var VALIDITY=$("#validity").val().trim();
            var ALG=$("#ALG_TYPE").val().trim();
            var LEN=$("#ALG_LEN").val().trim();
            var SIGALG=$("#SIG_ALG").val().trim();
            var StoreType=$("#Store_Type").val().trim();
            var alt_names=$("#alt_names").val().trim();
            var isRoot=document.getElementById("isRootCert").checked;
            if (CNAME == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterCommonName'));//NO I18N
                    return;
                }
                if (CNAME == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enteraltnames'));//NO I18N
                    return;
                }                
                if (ORGUNIT == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterOrganizationUnit'));//NO I18N
                    return;
                }
                if (ORG == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterOrganizationName'));//NO I18N
                    return;
                }
                if (LOCATION == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.specifylocation'));//NO I18N
                    return;
                }
                if (STATE == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterState'));//NO I18N
                    return;
                }
                if (COUNTRY == '') {
                    showAlert(I18N.getMsg('js.certificatecreation.enterCountryName'));//NO I18N
                    return;
                }
                else
                {
                    if(COUNTRY.length!==2)
                    {
                        showAlert(I18N.getMsg("js.countryName.characterLimit"));//NO I18N
                        return;
                    }
                }
                if(VALIDITY==''){
                    showAlert(I18N.getMsg('js.certificatecreation.enterValidityDays'));//NO I18N
                    return;                    
                }
                if(!validateNumberVal(VALIDITY)){
                    showAlert(I18N.getMsg('js.commonstr.enterValidDays'));//NO I18N
                    return;   
                }
            if(PASSWORD.length<6)
            {
               showAlert(I18N.getMsg('js.certificatecreation.KeyStorePasswordhasatleast6letters'));//NO I18N
                return;
            }
            if(alt_names!='' && !alt_names.match(/^[A-Za-z]/i))
            {
               showAlert(I18N.getMsg('js.pki.certificateCreation.dnsNameCheck'));//NO I18N
                return;
            }
            var isSelfSigned=false;
            if(document.getElementById("selfSigned").checked)
            {
                isSelfSigned=true;
            }
            var ajaxRequestUrl = '/api/pki/request/createCert';//NO I18N
            var ajaxRequestParams = 'CNAME='+CNAME+"&ALT_NAMES="+alt_names+'&ORGUNIT='+ORGUNIT+'&ORG='+ORG+'&LOCATION='+LOCATION+'&STATE='+STATE+'&COUNTRY='+COUNTRY+'&PASSWORD='+encodeURIComponent(PASSWORD)+'&ISSELFSIGNED='+isSelfSigned+'&VALIDITY='+VALIDITY+'&ALG='+ALG+'&LEN='+LEN+'&SIGALG='+SIGALG+'&StoreType='+StoreType+'&isRootCert='+isRoot;//NO I18N
            var content="";
            ajaxRequestWithCookie(ajaxRequestUrl,ajaxRequestParams,false,"",true,function(jsonData){
                    if(jsonData.Status==="Success")//NO I18N
                    {
                        messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                        content=jsonData.Certificate;
                        $("#newCertTable").css("display","block");
                        $("#createCertTable").css("display","none");
                        $("#forCSROnly").css("display","none");
                        $("#newCert").html(content);
                        //showDialog(content,'Created Certificate');
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }
            });
        },
        saveNewCert: function(){
            var VALIDITY=$("#validity").val();
            var ALG=$("#ALG_TYPE").val();
            var LEN=$("#ALG_LEN").val();
            var SIGALG=$("#SIG_ALG").val();
            var PASSWORD=$("#password").val();
            var FILE_CONTENT=document.getElementById("newCert").innerHTML;
            var CNAME=$("#common_name").val();
            var StoreType = $("#Store_Type").val();
            var CERTTYPE='CSR';//NO I18N
            var isRoot=document.getElementById("isRootCert").checked;
            if(document.getElementById("selfSigned").checked)
            {
                CERTTYPE='CER';//NO I18N
            }
            var params='CERTTYPE='+CERTTYPE+'&CNAME='+CNAME;//NO I18N
            var contentData = {};
            var object = {};
            object.FILE_CONTENT = FILE_CONTENT;
            contentData.FILECONTENT = JSON.stringify(object);            
            contentData.pmpcp=Get_Cookie('pmpcc');//No I18N
            contentData.PASSWORD=PASSWORD;
            params=params+'&VALIDITY='+VALIDITY+'&ALG='+ALG+'&LEN='+LEN+'&SIGALG='+SIGALG+'&StoreType='+StoreType+'&isRootCert='+isRoot;//NO I18N
            var ajaxRequestUrl = '/api/pki/request/saveNewCert?'+params; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,contentData,function(jsonData){
                    if(jsonData.Status==="Success")//NO I18N
                    {
                        messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                        if(CERTTYPE=="CSR")
                        {
                        redirectUrl("SSLMgmt/CreateCertificateList");//No I18N    
                        }
                        else
                        {
                            redirectUrl("SSLMgmt/SSL");//No I18N    
                        }
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }
            });
        },
        mailNewCert:function(){
            var emailAddr=$('#camail').val();
            if(!validateEmail(emailAddr)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
		return;
            }
var params='certName='+document.getElementById("common_name").value;//NO I18N
            var FILE_CONTENT=document.getElementById("newCert").innerHTML;
            params=params+'&CAMAILID='+$('#camail').val()+'&isCSR='+App.RequestCertController.isCSR;//NO I18N
            var contentData = {};
            var object = {};
            object.FILE_CONTENT = FILE_CONTENT;
            contentData.FILECONTENT = JSON.stringify(object);
            contentData.pmpcp=Get_Cookie('pmpcc');//NO I18N
            var ajaxRequestUrl = '/api/pki/request/mailNewCert?'+params; //No I18N
            ajaxapicall(ajaxRequestUrl,contentData,true,"");
        },
        exportNewCert:function(){
            
            var FILE_CONTENT=document.getElementById("newCert").innerHTML;
            var contentData = {};
            var object = {};
            object.FILE_CONTENT = FILE_CONTENT;
            var PASSWORD=$("#password").val();
            contentData.PASSWORD=PASSWORD;
            //contentData.FILECONTENT = JSON.stringify(object); 
            var params='certName='+document.getElementById("common_name").value+'&isCSR='+App.RequestCertController.isCSR;//NO I18N
//            if(App.RequestCertController.isCSR===true)
//            {
                params+='&PASSWORD='+contentData.PASSWORD;//NO I18N
//            }
            var ajaxRequestUrl = '/api/pki/request/exportNewCert?'+params; //No I18N
            if (!window.location.origin) {
                window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
        }
            location.href = window.location.origin + ajaxRequestUrl;
    },
    exportPrivateKey:function(){
        
            var params='certName='+document.getElementById("common_name").value+'&storetype='+document.getElementById("Store_Type").value;//NO I18N
            var ajaxRequestUrl = '/api/pki/request/exportPrivateKey?'+params; //No I18N
            if (!window.location.origin) {
                window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
    }
            location.href = window.location.origin + ajaxRequestUrl;
    }
    }
});

App.SSLMgmtCreateCertificateListController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        showCertDetailsDialog:function()
        {
            var app=this.get('controllers.application');
            app.send('opendialog','KeyContentsDisplay');//NO I18N
        },
        showmailCSRDetailsDialog:function()
        {
            var app=this.get('controllers.application');
            app.send('opendialog','MailCSRmodal');//NO I18N
        },
        showImportCertDialog:function()
        {
            var app=this.get('controllers.application');
            app.send('opendialog','importSignedCertificate');//NO I18N
        },
        deleteCsr:function()
        {
            
            
            
            var grid = jQuery("#CreatedCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) 
            {
                showAlert(I18N.getMsg('js.selectcsr.atleast')); //No I18N
                return;
        }
            vConfirmation(I18N.getMsg('js.csr.delete.confirmation'),function(){//NO I18N
                var csr_ids="";
                var csr_names="";
                $.each(selRowIds, function()
                {
                    var id = this;
                    var csr_id = grid.jqGrid('getCell', id, 'NEWCERTID'); //No I18N
                    var csr_name = $(grid.jqGrid('getCell',id, 'DOMAIN_NAME')).text();//NO I18N
                    if(csr_ids!=="")
                    {
                        csr_ids=csr_ids+","+csr_id;//NO I18N
                        csr_names=csr_names+","+csr_name;//NO I18N
    }
                    else
                    {
                        csr_ids=csr_id;
                        csr_names=csr_name;
                    }
});
                var ajaxRequestUrl = '/api/pki/request/deletecsr'; //No I18N
                var params="csr_ids="+csr_ids+"&csr_names="+csr_names;//NO I18N
                ajaxRequestWithCookie(ajaxRequestUrl,params,false,"",true,function(jsonData){
                        if(jsonData.Status==="Success")//NO I18N
                        {
                            messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                            {{App.Request.getGeneratedCerts();}}
                        }
                        else
                        {
                            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                        }                                                        
                });
            });
        }     

    }
});

App.SSLMgmtCreateCsrController = Ember.ObjectController.extend({
    needs:'CreateForm',//NO I18N
    actions : {
        createFormSubmit: function(){
            var app=this.get('controllers.CreateForm');//NO I18N
            app.send('createFormSubmit');//NO I18N
        },
        saveNewCert: function(){
            var app=this.get('controllers.CreateForm');//NO I18N
            app.send('saveNewCert');//NO I18N
        },
        mailNewCert: function(){
            var app=this.get('controllers.CreateForm');//NO I18N
            App.RequestCertController.isCSR=true;
            app.send('mailNewCert');//NO I18N
        },
        exportNewCert: function(){
            var app=this.get('controllers.CreateForm');//NO I18N
            App.RequestCertController.isCSR=true;
            app.send('exportNewCert');//NO I18N
        },
        exportPrivateKey: function(){
          var app = this.get('controllers.CreateForm');//NO I18N
          app.send('exportPrivateKey');//NO I18N
        },
        createCSRFromPrivateKey: function(){
            var fileData = new FormData();
            var pwd=$("#keyStorePassword").val();
            if ($('#textfile').val() == '') {
                showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                return;
        }
            
            var fileinput = document.getElementById("uploadKeyStoreFile");
            var files = fileinput.files;
            for(var i=0;i<files.length;i++)
            {
                var file=files[i];
                fileData.append("File",file);//NO I18N
            }
            fileData.append("pmpcp",Get_Cookie('pmpcc'));//No I18N
            fileData.append("pwd",pwd);//NO I18N
            var ajaxRequestUrl = '/api/pki/request/createCSRFromPK?'; //No I18N
            var browse=$('#uploadKeyStoreFile');
            var textfield=document.getElementById("textfile");
            getAjaxApiRequestForFile(ajaxRequestUrl, fileData, browse, textfield,true, function (jsonData) {
                if (jsonData.Status === "Success")
                        {
                    document.getElementById("keyStorePassword").value = "";
                            redirectUrl("SSLMgmt/CreateCertificateList");//No I18N
                        }
                });
        }
    }
});


App.LetsEncryptRequestHistoryController = Ember.ObjectController.extend({
   actions:{
       
   } 
});

App.LetsEncryptRequestListController = Ember.ObjectController.extend({
    actions:{
        deleteLetsEncryptRequests: function(){
                var grid = jQuery("#PendingCertList"); //No I18N
                var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                if(selRowIds == undefined || selRowIds.length == 0) {
                    showAlert(I18N.getMsg('js.letsencrypt.selectatleastone')); //No I18N
                    return;
                }
                vConfirmation(I18N.getMsg('letsencrypt.deleterequest.confirm'),function(){//NO I18N
                    var arr = new Array();
                    var req_ids="";
                    $.each(selRowIds, function()
                    {
                        var id = this;
                        var req_id = grid.jqGrid('getCell', id, 'REQUEST_ID'); //No I18N
                        if(req_ids!=="")
                        {
                            req_ids=req_ids+","+req_id;//NO I18N
                        }
                        else
                        {
                            req_ids=req_id;
                        }
                    });
                    var ajaxRequestUrl = '/api/pki/letsencrypt/deleteLetsEncryptRequests'; //No I18N
                    var params="req_ids="+req_ids+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
                    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                            if(jsonData.Status==="Success")//NO I18N
                            {
                                messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                                {{App.Request.letsEncryptRequestsList();}}
                            }
                            else
                            {
                                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                            }                                                        
                    });
                });
            },
            renewRequest: function(){
                var grid = jQuery("#PendingCertList"); //No I18N
                var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
                    showAlert(I18N.getMsg('js.letsencrypt.selectonerequest')); //No I18N
                    return;
            }
                var auth_status= grid.jqGrid('getCell',selRowIds,'AUTHORIZATION');//NO I18N
                if(auth_status==="no")
                {
                    showAlert(I18N.getMsg("letsencrypt.operater.renewauth"));//NO I18N
                    return;
                }
                var req_id = grid.jqGrid('getCell',selRowIds,'REQUEST_ID');//NO I18N
                var ajaxRequestUrl = '/api/pki/letsencrypt/renewRequest'; //No I18N
                var params = 'req_id='+req_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                            if(jsonData.req_id != undefined)
                            {
                                redirectUrl("SSLMgmt/LetsEncryptChallenges/"+jsonData.req_id); //No I18N
        }    
                            else
                            {
                                 if(jsonData.Status === "Success")
                                 {
                                     messageNotification("messageNotifySuccess",jsonData.Message);//No I18N                                                
                                 }
                                 else
                                 {
                                     messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                                 }
                                 {{App.Request.letsEncryptRequestsList();}}
                            }                           
   });
            },
            revoke: function(){
                var grid = jQuery("#PendingCertList"); //No I18N
                var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
                    showAlert(I18N.getMsg('js.letsencrypt.selectonerequest')); //No I18N
                    return;
                }
                var req_id = grid.jqGrid('getCell',selRowIds,'REQUEST_ID');//NO I18N
                var certificate = grid.jqGrid('getCell',selRowIds,'CERTIFICATE');//NO I18N
                var cert_status = grid.jqGrid('getCell',selRowIds,'CERT_STATUS');//NO I18N
                if($(cert_status).text()==="Revoked")
                {
                    showAlert(I18N.getMsg("js.letsencrypt.revokealready"));//NO I18N
                    return;
                }
                if(certificate === "yes")
                {
                    var ajaxRequestUrl = '/api/pki/letsencrypt/revokeCert'; //No I18N
                    var params = 'req_id='+req_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
                    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                        if(jsonData.Status === "Success")
                        {
                            messageNotification("messageNotifySuccess",jsonData.Message);//No I18N                                                
                        }
                        else
                        {
                            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                        }
                        {{App.Request.letsEncryptRequestsList();}}
                    });
                }
                else
                {
                    showAlert(I18N.getMsg("js.letsencrypt.revokenocert"))//NO I18N
                    return;
                }
            }
        }    
   });
   
   App.LetsEncryptChallengesController = Ember.ObjectController.extend({
       needs:'LetsEncryptRequest',//NO I18N
       actions : {
        verifyChallenges: function(){
            var app=this.get('controllers.LetsEncryptRequest');//NO I18N
            app.send('verifyChallenges');//NO I18N
        }
    }
   });
   
   App.GodaddyAddAccountController = Ember.ObjectController.extend({
      actions:{
          close: function() {
          return this.send('closeModal');//NO I18N
        },
        save: function(){
            var ajaxRequestUrl = '/api/pki/godaddy/updateAccount'; //No I18N
            var key = document.getElementById("key").value;
            var secret = document.getElementById("secret").value;
            if(key==="")
            {
                showAlert(I18N.getMsg("godaddy.key.alert"));//NO I18N
                return;
            }
            if(secret==="")
            {
                showAlert(I18N.getMsg("godaddy.secret.alert"));//NO I18N
                return;
            }
            var params = 'key='+encodeURIComponent(key)+"&secret="+encodeURIComponent(secret)+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            vConfirmation1(I18N.getMsg("godaddy.gdpr.consent"),function(){//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            if(jsonData.Status === "Success")
            {
                document.getElementById("closeButton").click();
                $("#createRequest").show();
                $(":submit").attr("disabled", false);
                $('#createOrderButton').show();
                $("#alertAddAccount").hide();
                messageNotification("messageNotifySuccess",jsonData.Message);//No I18N                                                                
            }
            else
            {
                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
            }
            
        });
            },I18N.getMsg("js.ack.req"),500);//NO I18N            
      } 
    }
   });
   
App.GoDaddyOrderController = Ember.ObjectController.extend({
   actions:{
       CreateOrder: function(){
            var ucc=false;
            var dv=false;
            var ov=false;
            var ev=false;            
            var reqParams="";            
            
            var commonName="";
            var keyOnRenewal="";
            var algLen="";
            var storeType="";
            var storePassword="";
            var certType="";
            var sanSize="";
            var san="";
            var period="";
            var rootType="";
            var contactJobTitle="";
            var contactFirstName="";
            var contactMiddleName="";
            var contactLastName="";
            var contactPhone="";
            var contactEmail="";
            var orgAddress1="";
            var orgAddress2="";
            var orgCity="";
            var orgCountry="";
            var orgState="";
            var orgPostalCode="";
            var orgAssumedName="";
            var orgName="";
            var orgPhone="";
            var orgRegAgent="";
            var orgRegNumber="";
            var intelVpro=false;           
            
            certType = document.getElementById("Cert_Type").value;
            var cert_type = certType.split("_");    
            if(cert_type[0]==="DV")
            {
                dv=true;
            }
            else if(cert_type[0]==="OV")
            {
                ov=true;
            }
            else if(cert_type[0]==="EV")
            {
                ev=true;
            }
            else if(cert_type[0]==="UCC")
            {
                ucc=true;
                if(cert_type[1]==="DV")
                {
                    dv=true;
                }
                else if(cert_type[1]==="OV")
                {
                    ov=true;
                }
                else if(cert_type[1]==="EV")
                {
                    ev=true;
                }
            }
            commonName=document.getElementById("common_name").value;
            if(commonName==="")
            {
                showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("js.sslcertificate.certificatename"))));//NO I18N
                return;
            }
            var cnames = commonName.split(",");
            if(cnames.length>1)
            {
                showAlert(I18N.getMsg("letsencrypt.commonnames.more"));//NO I18N
                return;
            }
            var index = commonName.indexOf(".");
            var length = commonName.length;
            if(index===-1 || index==length-1)
            {
                showAlert(I18N.getMsg("letsencrypt.properdomain.error"));//NO I18N
                return;
            }
            keyOnRenewal = $("input:radio[name ='RenewalKey']:checked").val();
            var fileData = new FormData();
            if(keyOnRenewal==="uploadkey")
            {
                if ($('#filename').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                var file = document.getElementById("uploadFile").files[0];
                fileData.append("File", file);//NO I18N
            }
            else
            {
                algLen = document.getElementById("ALG_LEN").value;
            }
            var browse=$('#uploadFile');
            var textfield=document.getElementById("filename");
            storeType = document.getElementById("Store_Type").value;
            storePassword = document.getElementById("password").value;
            if(storePassword.length<6)
            {
                showAlert(I18N.getMsg('js.certificatecreation.KeyStorePasswordhasatleast6letters'));//NO I18N
                return;
            }
            if(ucc)
            {
                sanSize = document.getElementById("san_slot").value;
                var sanNumber = $("#san_slot option:selected").text();
                san = document.getElementById("san_name").value;
                if(san=="")
                {
                    showAlert(I18N.getMsg("godaddy.san.alert"));//NO I18N
                    return;
                }
                var sans = san.split(",");
                if(sans.length>sanNumber)
                {
                    showAlert(I18N.getMsg("godaddy.san.exceed.alert"));//NO I18N
                    return;
                }
            }
            
            period = document.getElementById("cert_period").value;
            rootType = document.getElementById("Root_Type").value;
            if(ev)
            {
                contactJobTitle = document.getElementById("contact_jobtitle").value;
                if(contactJobTitle==="")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.requesterjobtitle"))));//NO I18N
                    return;
                }
            }            
            contactFirstName = document.getElementById("contact_firstname").value;
            if(contactFirstName==="")
            {
                showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.requester.firstname"))));//NO I18N
                return;
            }            
            contactMiddleName = document.getElementById("contact_middlename").value;
            contactLastName = document.getElementById("contact_lastname").value;
            if(contactLastName === "")
            {
                showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.requester.lastname"))));//NO I18N
                return;
            }
            contactPhone = document.getElementById("contact_phone").value;
            if(contactPhone === "")
            {
                showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.requester.phoneNumber"))));//NO I18N
                return;
            }
            if(!contactPhone.match(/^[0-9]*$/))
            {
                showAlert(I18N.getMsg("godaddy.valid.phone"));//NO I18N
                return;
            }
            contactEmail = document.getElementById("contact_email").value;
            if(contactEmail==="")
            {
                showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.requesteremail"))));//NO I18N
            }
            if(!validateEmail(contactEmail))
            {
                showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
		return;
            }
            if(ev||ov)
            {
                orgAddress1 = document.getElementById("org_address1").value;
                if(orgAddress1 === "")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.organization.address1"))));//NO I18N
                    return;
                }
                orgAddress2 = document.getElementById("org_address2").value;
                orgCity = document.getElementById("org_city").value;
                if(orgCity === "")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.organization.city"))));//NO I18N
                    return;
                }
                orgCountry = document.getElementById("org_country").value;
                orgState = document.getElementById("org_state").value;
                if(orgState === "")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.organization.state"))));//NO I18N
                    return;
                }
                orgPostalCode = document.getElementById("org_postalcode").value;
                orgName = document.getElementById("org_name").value;
                if(orgName==="")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.organization.name"))));//NO I18N
                    return;
                }
                orgPhone = document.getElementById("org_phone").value;
                if(orgPhone === "")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.requester.phoneNumber"))));//NO I18N
                    return;
                }
                if(!orgPhone.match(/^[0-9]*$/))
                {
                    showAlert(I18N.getMsg("godaddy.valid.phone"));//NO I18N
                    return;
                }
            }
            
            if(ev)
            {
                orgAssumedName = document.getElementById("org_assumedname").value;
                if(orgAssumedName==="")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.organization.assumedname"))));//NO I18N
                    return;
                }
                orgRegAgent = document.getElementById("org_regagent").value;
                if(orgRegAgent === "")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.organization.registrationagent"))));//NO I18N
                    return;
                }
                orgRegNumber = document.getElementById("org_regnumber").value;
                if(orgRegNumber==="")
                {
                    showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("godaddy.organization.registrationnumber"))));//NO I18N
                    return;
                }
            }
            
            if(ov)
            {
                if(document.getElementById("intelVproEnable").checked)
                {
                    intelVpro=true;
                }
                else
                {
                    intelVpro=false;
                }
            } 
//            reqParams="commonName="+commonName+"&keyOnRenewal="+keyOnRenewal+"&algLen="+algLen+"&storeType="+storeType+"&storePassword="+encodeURIComponent(storePassword)+"&certType="//NO I18N
//                    +certType+"&sanSize="+sanSize+"&san="+san+"&period="+period+"&rootType="+rootType+"&contactJobTitle="+contactJobTitle+"&contactFirstName="+contactFirstName//NO I18N
//                    +"&contactMiddleName="+contactMiddleName+"&contactLastName="+contactLastName+"&contactPhone="+contactPhone+"&contactEmail="+contactEmail+"&orgAddress1="+orgAddress1//NO I18N
//                    +"&orgAddress2="+orgAddress2+"&orgCity="+orgCity+"&orgCountry="+orgCountry+"&orgState="+orgState+"&orgPostalCode="+orgPostalCode+"&orgAssumedName="+orgAssumedName//NO I18N
//                    +"&orgName="+orgName+"&orgPhone="+orgPhone+"&orgRegAgent="+orgRegAgent+"&orgRegNumber="+orgRegNumber+"&intelVpro="+intelVpro;//NO I18N
            fileData.append("commonName", commonName);//NO I18N
            fileData.append("keyOnRenewal", keyOnRenewal);//NO I18N
            fileData.append("algLen", algLen);//NO I18N
            fileData.append("storeType", storeType);//NO I18N
            fileData.append("storePassword", encodeURIComponent(storePassword));//NO I18N
            fileData.append("certType", certType);//NO I18N
            fileData.append("sanSize", sanSize);//NO I18N
            fileData.append("san", san);//NO I18N
            fileData.append("period", period);//NO I18N
            fileData.append("rootType", rootType);//NO I18N
            fileData.append("contactJobTitle", contactJobTitle);//NO I18N
            fileData.append("contactFirstName", contactFirstName);//NO I18N
            fileData.append("contactMiddleName", contactMiddleName);//NO I18N
            fileData.append("contactLastName", contactLastName);//NO I18N
            fileData.append("contactPhone", contactPhone);//NO I18N
            fileData.append("contactEmail", contactEmail);//NO I18N
            fileData.append("orgAddress1", orgAddress1);//NO I18N
            fileData.append("orgAddress2", orgAddress2);//NO I18N
            fileData.append("orgCity", orgCity);//NO I18N
            fileData.append("orgCountry", orgCountry);//NO I18N
            fileData.append("orgState", orgState);//NO I18N
            fileData.append("orgPostalCode", orgPostalCode);//NO I18N
            fileData.append("orgAssumedName", orgAssumedName);//NO I18N
            fileData.append("orgName", orgName);//NO I18N
            fileData.append("orgPhone", orgPhone);//NO I18N
            fileData.append("orgRegAgent", orgRegAgent);//NO I18N
            fileData.append("orgRegNumber", orgRegNumber);//NO I18N
            fileData.append("intelVpro", intelVpro);//NO I18N
            var ajaxRequestUrl='/api/pki/godaddy/godaddyCreateOrder'; //No I18N            
            getAjaxApiRequestForFile(ajaxRequestUrl,fileData,browse,textfield,false,function(jsonData){               
                if(jsonData.Status === "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    redirectUrl("SSLMgmt/godaddy");//No I18N              
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N                              
                }               
           });
       }
   } 
}); 

App.GoDaddyController = Ember.ObjectController.extend({
   actions:{
       getCertificate: function(){
            var grid = jQuery("#PendingCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
                showAlert(I18N.getMsg('godaddy.select.anorder')); //No I18N
                return;
            }
            var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N            
            var ajaxUrl = '/api/pki/godaddy/getCertificate?order_id='+order_id; //No I18N  
            getAjaxApiRequest(ajaxUrl,"",function(jsonData){
                if(jsonData.Status === "Success")
                {            
                     messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                     {{App.Request.godaddyRequestsList();}}
                }
                else
                {
                     messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                }
            });
       },
       cacelOrder: function(){
           var grid = jQuery("#PendingCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
                showAlert(I18N.getMsg('godaddy.select.anorder')); //No I18N
                return;
            }
            var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
            var commonName = grid.jqGrid('getCell',selRowIds,'CommonName');//NO I18N
            var order_status = grid.jqGrid('getCell',selRowIds,'Order_Status');//NO I18N
            if(order_status==="CERTIFICATE ISSUED")
            {
                messageNotification("messageNotifyFailure",I18N.getMsg("godaddy.cancelorder.alert"));//NO I18N
                return;
            }
            var ajaxUrl = '/api/pki/godaddy/cancelOrder?order_id='+order_id+"&commonName="+commonName; //No I18N  
            getAjaxApiRequest(ajaxUrl,"",function(jsonData){
                if(jsonData.Status === "Success")
                {            
                     messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                     {{App.Request.godaddyRequestsList();}}
                }
                else
                {
                     messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                }
            });
       },
       deleteOrder: function()
       {
            var grid = jQuery("#PendingCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('godaddy.select.atlestanorder')); //No I18N
                return;
            }
            vConfirmation(I18N.getMsg('godaddy.deleteorder.confirm'),function(){//NO I18N
            var agentIds="";
            $.each(selRowIds, function()
            {
                var id = this;
                var agentId = grid.jqGrid('getCell', id, 'ID'); //No I18N
                if(agentIds!=="")
                {
                    agentIds=agentIds+","+agentId;//NO i18N
                }
                else
                {
                    agentIds=agentId;
                }
            });
            var ajaxUrl = '/api/pki/godaddy/deleteOrder?order_id='+agentIds; //No I18N  
            getAjaxApiRequest(ajaxUrl,"",function(jsonData){
                if(jsonData.Status === "Success")
                {            
                     messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                     {{App.Request.godaddyRequestsList();}}
                }
                else
                {
                     messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                }
            });
            });
       }
       
   } 
});
   
App.GoDaddyRenewController = Ember.ObjectController.extend({
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        renewCertificate:function(){
            var grid = jQuery("#PendingCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
                showAlert(I18N.getMsg('godaddy.select.anorder')); //No I18N
                return;
            }
            var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
            var commonName="";
            var sanSize="";
            var san="";
            var rootType="";
            var certType="";
            var period="";
            commonName=document.getElementById("common_name").value;
            if(commonName==="")
            {
                showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("js.sslcertificate.certificatename"))));//NO I18N
                return;
            }
            var cnames = commonName.split(",");
            if(cnames.length>1)
            {
                showAlert(I18N.getMsg("letsencrypt.commonnames.more"));//NO I18N
                return;
            }
            var keyOnRenewal = $("input:radio[name ='RenewalKey']:checked").val();
            var algLen="";
            var fileData = new FormData();
            if(keyOnRenewal==="uploadkey")
            {
                if ($('#filename').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                var file = document.getElementById("uploadFile").files[0];
                fileData.append("File", file);//NO I18N
            }
            else
            {
                algLen = document.getElementById("ALG_LEN").value;
            }
            var browse=$('#uploadFile');
            var textfield=document.getElementById("filename");
            var password = document.getElementById("password").value;
            var index = commonName.indexOf(".");
            var length = commonName.length;
            if(index===-1 || index==length-1)
            {
                showAlert(I18N.getMsg("letsencrypt.properdomain.error"));//NO I18N
                return;
            }
            period = document.getElementById("cert_period").value;
            rootType = document.getElementById("Root_Type").value;
            certType = document.getElementById("Cert_Type").value;
            var cert_type = certType.split("_");    
            if(cert_type[0]==="UCC")
            {
                sanSize = document.getElementById("san_slot").value;
                var sanNumber = $("#san_slot option:selected").text();
                san = document.getElementById("san_name").value;
                if(san=="")
                {
                    showAlert(I18N.getMsg("godaddy.san.alert"));//NO I18N
                    return;
                }
                var sans = san.split(",");
                if(sans.length>sanNumber)
                {
                    showAlert(I18N.getMsg("godaddy.san.exceed.alert"));//NO I18N
                    return;
                }
            }
            var ajaxUrl = '/api/pki/godaddy/renewCertificate?order_id='+order_id+"&keyOnRenewal="+keyOnRenewal+"&algLen="+algLen+"&password="+password+"&commonName="+commonName+"&sanSize="+sanSize+"&san="+san+"&certType="+certType+"&rootType="+rootType+"&period="+period; //No I18N  
            getAjaxApiRequestForFile(ajaxUrl,fileData,browse,textfield,false,function(jsonData){  
                if(jsonData.Status === "Success")
                {            
                    document.getElementById("closeButton").click();
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    {{App.Request.godaddyRequestsList();}}
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                }
            });
       }
    }
});
   
App.GoDaddyReissueController = Ember.ObjectController.extend({
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        reissueCertificate:function(){
            var grid = jQuery("#PendingCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
                showAlert(I18N.getMsg('godaddy.select.anorder')); //No I18N
                return;
            }
            var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
            var commonName="";
            var sanSize="";
            var san="";
            var rootType="";
            var certType="";
            var revokedelay="72";//NO I18N
            commonName=document.getElementById("common_name").value;
            if(commonName==="")
            {
                showAlert(I18N.getMsg("godaddy.formalert",new Array(I18N.getMsg("js.sslcertificate.certificatename"))));//NO I18N
                return;
            }
            var cnames = commonName.split(",");
            if(cnames.length>1)
            {
                showAlert(I18N.getMsg("letsencrypt.commonnames.more"));//NO I18N
                return;
            }
            var index = commonName.indexOf(".");
            var length = commonName.length;
            if(index===-1 || index==length-1)
            {
                showAlert(I18N.getMsg("letsencrypt.properdomain.error"));//NO I18N
                return;
            }
            var keyOnRenewal = $("input:radio[name ='RenewalKey']:checked").val();
            var algLen="";
            var fileData = new FormData();
            if(keyOnRenewal==="uploadkey")
            {
                if ($('#filename').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                var file = document.getElementById("uploadFile").files[0];
                fileData.append("File", file);//NO I18N
            }
            else
            {
                algLen = document.getElementById("ALG_LEN").value;
            }
            var browse=$('#uploadFile');
            var textfield=document.getElementById("filename");
            revokedelay=document.getElementById("delay_existing").value;
            if(revokedelay>168||revokedelay<72)
            {
                showAlert(I18N.getMsg("godaddy.reissuedelay.alert"));//NO I18N
                return;
            }
            rootType = document.getElementById("Root_Type").value;
            certType = document.getElementById("Cert_Type").value;
            var cert_type = certType.split("_");    
            if(cert_type[0]==="UCC")
            {
                sanSize = document.getElementById("san_slot").value;
                var sanNumber = $("#san_slot option:selected").text();
                san = document.getElementById("san_name").value;
                if(san=="")
                {
                    showAlert(I18N.getMsg("godaddy.san.alert"));//NO I18N
                    return;
                }
                var sans = san.split(",");
                if(sans.length>sanNumber)
                {
                    showAlert(I18N.getMsg("godaddy.san.exceed.alert"));//NO I18N
                    return;
                }
            }
            var password = document.getElementById("password").value;
            var ajaxUrl = '/api/pki/godaddy/reissueCertificate?order_id='+order_id+"&keyOnRenewal="+keyOnRenewal+"&algLen="+algLen+"&password="+password+"&commonName="+commonName+"&sanSize="+sanSize+"&san="+san+"&certType="+certType+"&rootType="+rootType+"&delayExistingRevoke="+revokedelay; //No I18N  
            getAjaxApiRequestForFile(ajaxUrl,fileData,browse,textfield,false,function(jsonData){  
                if(jsonData.Status === "Success")
                {            
                    document.getElementById("closeButton").click();
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    {{App.Request.godaddyRequestsList();}}
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                }
            });
       }
    }
});
   
App.GoDaddyRevokeController = Ember.ObjectController.extend({
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        revokeCertificate:function(){
            var grid = jQuery("#PendingCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
                showAlert(I18N.getMsg('godaddy.select.anorder')); //No I18N
                return;
            }
            var order_id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
            var commonName = grid.jqGrid('getCell',selRowIds,'CommonName');//NO I18N            
            var reason = document.getElementById("reason").value;
            var ajaxUrl = '/api/pki/godaddy/revokeCertificate?order_id='+order_id+"&commonName="+commonName+"&reason="+reason; //No I18N  
            getAjaxApiRequest(ajaxUrl,"",function(jsonData){
                if(jsonData.Status === "Success")
                {            
                    document.getElementById("closeButton").click();
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    {{App.Request.godaddyRequestsList();}}
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                }
            });
       }
    }
});
   
App.LetsEncryptRequestController = Ember.ObjectController.extend({
    actions:{
        letsEncryptCreate:function(){
            var CNAME=$("#common_name").val();
            var SAN = $("#san_name").val();
            var ORGUNIT=$("#orgunit").val();
            var ORG=$("#org").val();
            var LOCATION=$("#loc").val();
            var STATE=$("#isstate").val();
            var COUNTRY=$("#country").val();
            var PASSWORD=$("#password").val();
            var VALIDITY=$("#validity").val();
            var ALG=$("#ALG_TYPE").val();
            var LEN=$("#ALG_LEN").val();
            var SIGALG=$("#SIG_ALG").val();
            var StoreType=$("#Store_Type").val();
            var challengeType = $("#Challenge_Type").val();
            var default_dns_server=$("#dns_default_server").val();               
            
            if($.trim(CNAME)==="")
            {
                showAlert(I18N.getMsg("letsencrypt.enter.commonname"));//NO I18N
                return;
            }
            var cnames = CNAME.split(",");
            if(cnames.length>1)
            {
                showAlert(I18N.getMsg("letsencrypt.commonnames.more"));//NO I18N
                return;
            }
            var sans = SAN.split(",");
            if($.trim(SAN)!=="" && sans.length<=100)
            {
                CNAME+=","+SAN;//NO I18N
            }
            else if(sans.length>100)
            {
                showAlert(I18N.getMsg("letsencrypt.san.exceeds100"));//NO I18N
                return;
            }
            if(validateDomainNames(CNAME))
            {
                return;
            }
            var keyRenewal =  $("input:radio[name ='RenewalKey']:checked").val();
            var fileData = new FormData();
            if(keyRenewal==="uploadkey")
            {
                if ($('#filename').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                var file = document.getElementById("uploadFile").files[0];
                fileData.append("File", file);//NO I18N
            }
            var browse=$('#uploadFile');
            var textfield=document.getElementById("filename");
            if(PASSWORD.length<6)
            {
               showAlert(I18N.getMsg('js.certificatecreation.KeyStorePasswordhasatleast6letters'));//NO I18N
                return;
            }
            var params='?KeyRenewal='+keyRenewal+'&CNAME='+CNAME+'&ORGUNIT='+ORGUNIT +'&ORG='+ORG+'&LOCATION='+LOCATION+'&STATE='+STATE+'&COUNTRY='+COUNTRY+'&PASSWORD='+encodeURIComponent(PASSWORD)+'&VALIDITY='+VALIDITY+'&ALG='+ALG+'&LEN='+LEN+'&SIGALG='+SIGALG+'&StoreType='+StoreType+'&ChallengeType='+challengeType+"&defaultDNS="+default_dns_server;//NO I18N
            
            fileData.append("PASSWORD",PASSWORD);//NO I18N
            fileData.append("pmpcp",Get_Cookie('pmpcc'));//NO I18N
            var ajaxRequestUrl='/api/pki/letsencrypt/certRequest'+params; //No I18N            
            getAjaxApiRequestForFile(ajaxRequestUrl,fileData,browse,textfield,false,function(jsonData){
               if(jsonData.req_id != undefined)
               {
                   redirectUrl("SSLMgmt/LetsEncryptChallenges/"+jsonData.req_id); //No I18N
               }
               else
               {
                    if(jsonData.Status === "Success")
                    {
                        messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                            redirectUrl("SSLMgmt/LetsEncryptRequestList");//No I18N              
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                        redirectUrl("SSLMgmt/LetsEncryptRequestList");//No I18N            
                    }
               }
           });
        },
        verifyChallenges: function(){
            var ajaxRequestUrl = '/api/pki/letsencrypt/verifyChallengesAndCert';//NO I18N            
            var params="req_id="+App.RequestCertController.req_id;//NO I18N
            var grid = jQuery("#requestChallenges");//NO I18N            
            var rows = grid.getDataIDs();
            var flag = false;
            var invalidDomains="";
            var invalidDomainIds="";
            $.each(rows, function()
            {
                var id = this;
                var status = grid.jqGrid('getCell',id,'status');//NO I18N
                if(status === 'invalid')
                {
                    flag=true;
                    var domain = grid.jqGrid('getCell',id,'domain');//NO I18N
                    var challengeId = grid.jqGrid('getCell',id,'challengeId');//NO I18N
                    if(invalidDomains=="")
                    {
                        invalidDomains=domain;
                        invalidDomainIds=domain+","+challengeId;//NO I18N
                }
                    else
                    {
                        invalidDomains+=","+domain;//NO I18N
                        invalidDomainIds+=","+domain+","+challengeId;//NO I18N
                    }                    
                }
            });
            if(flag)
            {
                vConfirmation('Get new challenges for the domains '+invalidDomains+' ?',function(){//NO I18N
                    ajaxRequestUrl = '/api/pki/letsencrypt/getNewChallenge';//NO I18N
                    params = 'domain='+invalidDomainIds+'&req_id='+App.RequestCertController.req_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
                    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                        if(jsonData.Status === "Success")
                        {            
                             App.Request.letsEncryptRequestsChallenges(App.RequestCertController.req_id);        
            }
                        else
                        {
                             messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
                        }
                    });
                });
                
            }
            else
            {
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                if(jsonData.req_id != undefined)
                {
                    App.Request.letsEncryptRequestsChallenges(jsonData.req_id);
                }
                else if(jsonData.deployStatus != undefined)
                { 
                    document.getElementById("deployStatus").click();
                    App.Request.deployStatus(jsonData);
                }
                else
                {
                     if(jsonData.Status === "Success")
                     {
                         messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                     }
                     else
                     {
                         messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                     }
                     redirectUrl("SSLMgmt/LetsEncryptRequestList");//No I18N              
                }
                
            });
        }
            
    }
    }
});

App.AssignDefaultDNSController = Ember.ObjectController.extend({
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        save: function() {
                    var grid = jQuery("#PendingCertList"); //No I18N
                    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                    if(selRowIds == undefined || selRowIds.length == 0) {
                        showAlert(I18N.getMsg('js.letsencrypt.selectatleastone')); //No I18N
                        return;
                    }
                    var req_ids="";            
                    $.each(selRowIds, function()
                    {
                        var id = this;        
                        var req_id = grid.jqGrid('getCell', id, 'REQUEST_ID'); //No I18N                
                        if(req_ids!=="")
                        {
                            req_ids=req_ids+","+req_id;//NO I18N
                        }
                        else
                        {
                            req_ids=req_id;
                        }
                    });
                    var ajaxRequestUrl = '/api/pki/letsencrypt/setRequestDefaultDNS'; //No I18N
                    var dns_id = document.getElementById("dns_default_server").value;
                    var params="req_id="+req_ids+"&dns_id="+dns_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
                    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                       if(jsonData.Status==="Success")//NO I18N
                            {
                                document.getElementById("closeButton").click();
                                messageNotification("messageNotifySuccess",jsonData.Message);//No I18N                
                            }
                            else
                            {
                                messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                            }    
                    });
                }
            }
    });

App.DeployStatusController = Ember.ObjectController.extend({
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        }
    }
    });
App.AddDefaultDNSController = Ember.ObjectController.extend({
   actions:{
       close: function() {
          return this.send('closeModal');//NO I18N
        },
        save: function(){
           var data = {};
           var ajaxUrl = '/api/pki/letsencrypt/updateGlobalDNS';//NO I18N
           var dns_server = document.getElementById("dns_server").value;
           data.dns_server = dns_server;
           if(dns_server==="azure")
            {
            var sub_id = document.getElementById("azure_subscription_id").value;
            if(sub_id==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Subscription ID")));//NO I18N
                return;
            }
            var ten_id = document.getElementById("azure_tenant_id").value;
            if(ten_id==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Directory ID")));//NO I18N
                return;
            }
            var cli_id = document.getElementById("azure_client_id").value;
            if(cli_id==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Application ID")));//NO I18N
                return;
            }
            var azure_password=document.getElementById("azure_secret").value;
            if(azure_password==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Key")));//NO I18N
                return;
            }
            var res_group_name=document.getElementById("azure_resource_group").value;
            if(res_group_name==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("ResourceGroup Name")));//NO I18N
                return;
            }
            data.azure_subscription_id=sub_id;
            data.azure_tenant_id=ten_id;
            data.azure_client_id=cli_id;
            data.azure_secret=azure_password;
            data.azure_resource_group=res_group_name;
            }
            else if(dns_server==="cloudflare")
            {                    
                var email = document.getElementById("cloudflare_email").value;
                if(email==="")
                {
                    showAlert(I18N.getMsg("cloudflare.enter.email"));//NO I18N
                    return;
                }
                if(!validateEmail(email)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
		return;
                }
                var auth_key = document.getElementById("cloudflare_auth_key").value;
                if(auth_key === "")
                {
                    showAlert(I18N.getMsg("cloudflare.enter.authkey"));//NO I18N
                    return;
                }                    
                data.cloudflare_email=email;
                data.cloudflare_auth_key=auth_key;
            }
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            if(document.getElementById("enableGlobalDNS").checked)
            {
                data.enable=true;
            }
            else
            {
                data.enable=false;
            }
            data.id=App.RequestCertController.dns_id;
            getAjaxApiRequest(ajaxUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {   
                    document.getElementById("closeButton").click();
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N                    
                    {{App.Request.defaultDNSServers()}}
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });
       }
   } 
});

App.DNSProviderController = Ember.ObjectController.extend({
   actions:{
       enableStatus:function(){
        var grid = jQuery("#PKILetsEncrypt"); //No I18N 
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
            showAlert(I18N.getMsg('dns.select.onedns')); //No I18N
            return;
        }
        var id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
        var ajaxUrl = '/api/pki/letsencrypt/changeDefaultDNSstatus?id='+id+"&pmpcp="+Get_Cookie('pmpcc')+"&status="+true;//NO I18N
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {   
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    {{App.Request.defaultDNSServers()}}
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });
       },
       disableStatus:function(){
        var grid = jQuery("#PKILetsEncrypt"); //No I18N 
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
            showAlert(I18N.getMsg('dns.select.onedns')); //No I18N
            return;
        }
        var id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
        var ajaxUrl = '/api/pki/letsencrypt/changeDefaultDNSstatus?id='+id+"&pmpcp="+Get_Cookie('pmpcc')+"&status="+false;//NO I18N
        getAjaxApiRequest(ajaxUrl,"",function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {   
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    {{App.Request.defaultDNSServers()}}
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });
       },       
       deleteDNS:function(){
            var grid = jQuery("#PKILetsEncrypt"); //No I18N 
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
                showAlert(I18N.getMsg('dns.select.onedns')); //No I18N
                return;
            }
            var id = grid.jqGrid('getCell', selRowIds, 'ID'); //No I18N
            var ajaxUrl = '/api/pki/letsencrypt/deleteGlobalDNS?id='+id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            vConfirmation(I18N.getMsg('deletedns.confirm.alert'),function(){//NO I18N
            getAjaxApiRequest(ajaxUrl,"",function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {   
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    {{App.Request.defaultDNSServers()}}
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });
        });
       }      
   } 
});

App.AgentController = Ember.ObjectController.extend({
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        save: function() {
            var data = {};
            var deployCertificate = true;
            var ajaxUrl = '/api/pki/letsencrypt/mapDomainAgent';//NO I18N
            var challenge_type=$('input[name=challenge_type]:checked').val();
            data.challenge_type=challenge_type;
            var dns=false;
            var domain = document.getElementById("domainName").value;
            var mapping_id = App.RequestCertController.mapping_id;
            data.mappingId=mapping_id;
            data.domain=domain;
            if(domain === "")
            {
                showAlert(I18N.getMsg("js.sslcertificate.enterDomainName"));//NO I18N
                return;
            }
            if(challenge_type==="dns-01")
            {
                dns=true;
                var dns_server = document.getElementById("dns_server").value;
                data.dns_server = dns_server;
                if(dns_server==="azure")
                {
                var sub_id = document.getElementById("azure_subscription_id").value;
                if(sub_id==="")
                {
                    showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Subscription ID")));//NO I18N
                    return;
                }
                var ten_id = document.getElementById("azure_tenant_id").value;
                if(ten_id==="")
                {
                    showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Directory ID")));//NO I18N
                    return;
                }
                var cli_id = document.getElementById("azure_client_id").value;
                if(cli_id==="")
                {
                    showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Application ID")));//NO I18N
                    return;
                }
                var azure_password=document.getElementById("azure_secret").value;
                if(azure_password==="")
                {
                    showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Key")));//NO I18N
                    return;
                }
                var res_group_name=document.getElementById("azure_resource_group").value;
                if(res_group_name==="")
                {
                    showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("ResourceGroup Name")));//NO I18N
                    return;
                }
//                var zone_name=document.getElementById("azure_zone_name").value;
//                if(zone_name==="")
//                {
//                    showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Zone Name")));//NO I18N
//                    return;
//                }
                data.azure_subscription_id=sub_id;
                data.azure_tenant_id=ten_id;
                data.azure_client_id=cli_id;
                data.azure_secret=azure_password;
                data.azure_resource_group=res_group_name;
                //data.azure_zone_name=zone_name;
                }
                else if(dns_server==="cloudflare")
                {
                    var email = document.getElementById("cloudflare_email").value;
                    if(email==="")
                    {
                        showAlert(I18N.getMsg("cloudflare.enter.email"));//NO I18N
                        return;
                    }
                    if(!validateEmail(email)) {
                    showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
                    return;
                    }
                    var auth_key = document.getElementById("cloudflare_auth_key").value;
                    if(auth_key === "")
                    {
                        showAlert(I18N.getMsg("cloudflare.enter.authkey"));//NO I18N
                        return;
                    }
//                    var zone_name=document.getElementById("cloudflare_zone_name").value;
//                    if(zone_name==="")
//                    {
//                        showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Zone Name")));//NO I18N
//                        return;
//                    }
                    data.cloudflare_email=email;
                    data.cloudflare_auth_key=auth_key;
                    //data.cloudflare_zone_name=zone_name;
                }
                if(!document.getElementById("deploy_certificate").checked)
                {
                    deployCertificate=false;
                }
            }            
            data.deployCertificate=deployCertificate;
            if(deployCertificate)
            {            
                var agentId;
                var serverName;
                var userName;
                var password;
                var agenttype;                
            if(document.getElementById("windows").checked)
            {
                agentId = document.getElementById("Agents").value;
                agenttype="Windows";//NO I18N
                    data.agentType=agenttype;
                    data.agentId=agentId;                
            }
            else
            {
                agenttype="Linux";//NO I18N
                serverName = document.getElementById("serverName").value;
                if(serverName=="")
                {
                    showAlert(I18N.getMsg("js.radius.validserver"));//NO I18N
                    return;
                }
                userName = document.getElementById("userName").value;
                if(userName==="")
                {
                    showAlert(I18N.getMsg("js.resourcecredential.invalidusernameorpassword"));//NO I18N
                    return;
                }
                password = document.getElementById("password").value;
                if(password==="")
                {
                    showAlert(I18N.getMsg("js.resourcecredential.invalidusernameorpassword"));//NO I18N
                    return;
                }
                    data.agentType=agenttype;
                    data.serverName=serverName;
                    data.userName=userName;
                    data.password=encodeURIComponent(password);                
            }
            var path = document.getElementById("path").value;
                if(path==="" && !dns)
            {
                showAlert(I18N.getMsg('pki.agent.validpath'));//NO I18N
                return;
            }
            var keypath = document.getElementById("keypath").value;
            var certFileName="no";//NO I18N
            var keyFileName = "no";//NO I18N
            var storeFileName = "no";//NO I18N
            if(document.getElementById("certificate").checked || document.getElementById("privateKey").checked || document.getElementById("keyStore").checked)
            {
                if(keypath==="")
                {
                    showAlert(I18N.getMsg("pki.agent.validcertpath"));//NO I18N
                    return;
                }
               if(document.getElementById("certificate").checked)
               {
                   certFileName = document.getElementById("certFileName").value;
               }
               if(document.getElementById("privateKey").checked)
               {
                   keyFileName = document.getElementById("keyFileName").value;
               }
               if(document.getElementById("keyStore").checked)
               {
                   storeFileName = document.getElementById("storeFileName").value;
               }
            }  
            else
            {
                    if(dns)
                    {
                        showAlert(I18N.getMsg("letsencrypt.selectonecerttype"));//NO I18N
                        return;
                    }
                keypath="";
            }
            var port = document.getElementById("port").value;
            var agentName = $("#Agents option:selected").text();
                data.path=path;
                data.keypath=keypath;
                data.agentName=agentName;                
                data.certFileName=certFileName;
                data.keyFileName=keyFileName;
                data.storeFileName=storeFileName;
                data.port=port;                
            }
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            getAjaxApiRequest(ajaxUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {   
                    document.getElementById("closeButton").click();
                    {{App.Request.letsEncryptDomainMappings(App.RequestCertController.domain);}}
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
});
        }
    }
});

App.CreateTxtRecordController = Ember.ObjectController.extend({
   needs:'application',//NO I18N
   actions:{
       close: function() {
          return this.send('closeModal');//NO I18N
      },
      save: function(){
           var data = {};
           var ajaxUrl = '/api/pki/godaddy/createtxtrecord';//NO I18N
           var domain = document.getElementById("domain_name").value;
           if(domain==="")
           {
               showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Zone Name")));//NO I18N
               return;
      }
//           var index = domain.indexOf(".");
//            var length = domain.length;
//            if(index===-1 || index==length-1)
//            {
//                showAlert(I18N.getMsg("letsencrypt.properdomain.error"));//NO I18N
//                return;
//   }
            data.domain=domain;
           var dns_server = document.getElementById("dns_server").value;
           data.dns_server = dns_server;
           if(dns_server==="azure")
            {
            var sub_id = document.getElementById("azure_subscription_id").value;
            if(sub_id==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Subscription ID")));//NO I18N
                return;
            }
            var ten_id = document.getElementById("azure_tenant_id").value;
            if(ten_id==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Directory ID")));//NO I18N
                return;
            }
            var cli_id = document.getElementById("azure_client_id").value;
            if(cli_id==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Application ID")));//NO I18N
                return;
            }
            var azure_password=document.getElementById("azure_secret").value;
            if(azure_password==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("Key")));//NO I18N
                return;
            }
            var res_group_name=document.getElementById("azure_resource_group").value;
            if(res_group_name==="")
            {
                showAlert(I18N.getMsg("letsencrypt.azureform.alert",new Array("ResourceGroup Name")));//NO I18N
                return;
            }
            data.azure_subscription_id=sub_id;
            data.azure_tenant_id=ten_id;
            data.azure_client_id=cli_id;
            data.azure_secret=azure_password;
            data.azure_resource_group=res_group_name;
            }
            else if(dns_server==="cloudflare")
            {                    
                var email = document.getElementById("cloudflare_email").value;
                if(email==="")
                {
                    showAlert(I18N.getMsg("cloudflare.enter.email"));//NO I18N
                    return;
                }
                if(!validateEmail(email)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
		return;
                }
                var auth_key = document.getElementById("cloudflare_auth_key").value;
                if(auth_key === "")
                {
                    showAlert(I18N.getMsg("cloudflare.enter.authkey"));//NO I18N
                    return;
                }                    
                data.cloudflare_email=email;
                data.cloudflare_auth_key=auth_key;
            }
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N            
            data.id=App.RequestCertController.dns_id;
            var txt_name = document.getElementById("txt_name").value;
            if(txt_name=="")
            {
                showAlert(I18N.getMsg("godaddy.provide.txtname"));//NO I18N
                return;
            }
            data.txt_name=txt_name;
            var txt_value=document.getElementById("txt_value").value;
            if(txt_value=="")
            {
                showAlert(I18N.getMsg("godaddy.provide.txtvalue"));//NO I18N
                return;
            }
            data.txt_value=txt_value;
            getAjaxApiRequest(ajaxUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {   
                    document.getElementById("closeButton").click();
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N                    
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
});
       }
   }
});

App.GoDaddyOrderDetailsController = Ember.ObjectController.extend({
   needs:'application',//NO I18N
   actions:{
    exportNewCert:function()
    {
        var params="order_id="+App.RequestCertController.order_id;//NO I18N       
        var ajaxRequestUrl = '/api/pki/godaddy/exportCert?'+params; //No I18N
        if (!window.location.origin) {
            window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
        }
        location.href = window.location.origin + ajaxRequestUrl;
    },
    exportPrivateKey:function()
    {
        var params="order_id="+App.RequestCertController.order_id;//NO I18N       
        var ajaxRequestUrl = '/api/pki/godaddy/exportPrivateKey?'+params; //No I18N
        if (!window.location.origin) {
            window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
        }
        location.href = window.location.origin + ajaxRequestUrl;
    },
    exportKeyStore:function()
    {
        var params="order_id="+App.RequestCertController.order_id;//NO I18N       
        var ajaxRequestUrl = '/api/pki/godaddy/exportKeyStore?'+params; //No I18N
        if (!window.location.origin) {
            window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
        }
        location.href = window.location.origin + ajaxRequestUrl;
    },
    exportCSR:function()
    {
        var params="order_id="+App.RequestCertController.order_id;//NO I18N       
        var ajaxRequestUrl = '/api/pki/godaddy/exportCSR?'+params; //No I18N
        if (!window.location.origin) {
            window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
    }
        location.href = window.location.origin + ajaxRequestUrl;
    }
   }
});

App.ShowCertificateController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
    },
    
    saveNewCert: function(){
        var params="req_id="+App.RequestCertController.req_id;//NO I18N    
                saveLetsEncryptCertificate(params);
            
    },
    mailNewCert:function()
    {
        var emailAddr=$('#camail').val();
        if(!validateEmail(emailAddr)) {
            showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
            return;
        }
 var params="req_id="+App.RequestCertController.req_id+'&CAMAILID='+$('#camail').val();//NO I18N
        var ajaxRequestUrl = '/api/pki/letsencrypt/mailNewCert?'+params; //No I18N
        ajaxapicall(ajaxRequestUrl,"pmpcp="+Get_Cookie('pmpcc'),true,"");//NO I18N
    },
    exportNewCert:function()
    {
        var params="req_id="+App.RequestCertController.req_id;//NO I18N       
        var ajaxRequestUrl = '/api/pki/letsencrypt/exportCert?'+params; //No I18N
        if (!window.location.origin) {
            window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
        }
        location.href = window.location.origin + ajaxRequestUrl;
    },
    exportPrivateKey:function()
    {
        var params="req_id="+App.RequestCertController.req_id;//NO I18N       
        var ajaxRequestUrl = '/api/pki/letsencrypt/exportPrivateKey?'+params; //No I18N
        if (!window.location.origin) {
            window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
        }
        location.href = window.location.origin + ajaxRequestUrl;
    },
    exportKeyStore:function()
    {
        var params="req_id="+App.RequestCertController.req_id;//NO I18N       
        var ajaxRequestUrl = '/api/pki/letsencrypt/exportKeyStore?'+params; //No I18N
        if (!window.location.origin) {
            window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
        }
        location.href = window.location.origin + ajaxRequestUrl;
    },
    exportCSR:function()
    {
        var params="req_id="+App.RequestCertController.req_id;//NO I18N       
        var ajaxRequestUrl = '/api/pki/letsencrypt/exportCSR?'+params; //No I18N
        if (!window.location.origin) {
            window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
    }
        location.href = window.location.origin + ajaxRequestUrl;
    }
    }
});


function validateDomainNames(domainNames)
{
    var domains = domainNames.split(",");
    var returnValue;
    domains.forEach(function(domain){
        if(domain.indexOf("*.")===0 || domain.lastIndexOf(".")==domain.length-1 || domain.indexOf("*")!=-1)
        {
            showAlert(I18N.getMsg("letsencrypt.wildcarddomain.notallowed"));//NO I18N
            returnValue = true;
        }
        var index = domain.indexOf(".");
        var length = domain.length;
        if(index===-1 || index==length-1)
        {
            showAlert(I18N.getMsg("letsencrypt.properdomain.error"));//NO I18N
            returnValue = true;
        }
    });
    
   return returnValue;
}

function downloadChallengeFile(fileName,textToWrite)
{    
    var textFileAsBlob = new Blob([textToWrite], {type:'text/binary'});
    var fileNameToSaveAs = fileName;
    var isIE = detectIE();        
    var downloadLink = document.createElement("a");
    downloadLink.download = fileNameToSaveAs;
    downloadLink.innerHTML = "Download File";//No I18N
    if (isIE)
    {
        window.navigator.msSaveBlob(textFileAsBlob, fileNameToSaveAs);
    }
    else if (window.webkitURL != null)
    {
            // Chrome allows the link to be clicked
            // without actually adding it to the DOM.
            downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
            downloadLink.click();
    }
    else
    {
            // Firefox requires the link to be added to the DOM
            // before it can be clicked.
            downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
            downloadLink.onclick = destroyClickedElement;
            downloadLink.style.display = "none";
            document.body.appendChild(downloadLink);
    downloadLink.click();
}
}

function saveLetsEncryptCertificate(params)
{
    var ajaxRequestUrl = '/api/pki/letsencrypt/saveLetsCert'; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,params+"&pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
        if(jsonData.status==="Success")//NO I18N
        {                            
            location.href="#/SSLMgmt/SSL";//No I18N    
            messageNotification("messageNotifySuccess",jsonData.msg);//No I18N
        }
        else
        {
            messageNotification("messageNotifyFailure",jsonData.msg);//No I18N
        }
    });
}

function saveGoDaddyCertificate(params)
{
    var ajaxRequestUrl = '/api/pki/godaddy/saveGoDaddyCert'; //No I18N
    getAjaxApiRequest(ajaxRequestUrl,params+"&pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
        if(jsonData.status==="Success")//NO I18N
        {                            
            location.href="#/SSLMgmt/SSL";//No I18N    
            messageNotification("messageNotifySuccess",jsonData.msg);//No I18N
        }
        else
        {
            messageNotification("messageNotifyFailure",jsonData.msg);//No I18N
        }
    });
}

App.MailCSRmodalController=Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions : {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        sendcsrmail: function(){
            var mail=$('#csrMail').val()
            if(!validateEmail(mail)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
		return;
            }
            var reqParams="newCertId="+App.RequestCertController.newCertId+"&MAILID="+mail; //No I18N
            if(document.getElementById("mailcsr").checked)
            {
                reqParams=reqParams+"&mailCSR=true";//No I18N
            }
            if(document.getElementById("mailprivatekeycsr").checked)
            {
                reqParams=reqParams+"&mailPrivateKey=true";//No I18N
            }
            reqParams=reqParams+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            var ajaxRequestUrl='/api/pki/request/mailCSR'; //No I18N
            ajaxapicall(ajaxRequestUrl,reqParams,true,"");
        }
    }
});

function showAdditionalFields()
{
    $('#AddField').toggle();
}

App.LETSMgmtNewRegistrationController = Ember.ObjectController.extend({
    actions: {
        NewRegistration: function()
        {            
            var account_name=$("#ACCOUNT_NAME").val();
            var email = $("#MAIL").val();
            if(account_name.trim()==="")
            {
                showAlert(I18N.getMsg('js.letsencrypt.enteraccountname'));//NO I18N
                return ;
            }
            email=email.trim();
            if(!validateEmail(email)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
                return;
            }
            
            if(!document.getElementById("subAgreement").checked)
            {
                showAlert(I18N.getMsg('letsencrypt.accept.agreement'));//NO I18N
                return;
            }
            var reqParams = "accountName="+account_name+"&mail="+email+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            var reqURL = "/api/pki/letsencrypt/newRegistration";//No I18N
            vConfirmation1(I18N.getMsg("js.gdpr.letsencrypt.consent"),function(){//NO I18N
            ajaxapicall(reqURL,reqParams,true,"LETSMgmt/LETSAccount");//NO I18N
            },I18N.getMsg("js.ack.req"),500);//NO I18N
        }
    }
});


App.LETSMgmtAddNewAccountController = Ember.ObjectController.extend({
    actions : {
        addNewAccount : function(){
            var textfield=document.getElementById("filename");
            var fileData = new FormData();
            var file = document.getElementById("uploadFile").files[0];
            fileData.append("File", file);//NO I18N
            var browse=$('#uploadFile');            
            var account_name = document.getElementById("ACCOUNT_NAME").value;
            if(account_name.trim()==="")//NO I18N
            {
                showAlert(I18N.getMsg('js.letsencrypt.enteraccountname'));//NO I18N
                return ;
            }
            if ($('#filename').val() == '') {
                showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                return;
            }
            var email = document.getElementById("MAIL").value;
            email=email.trim();
            if(!validateEmail(email)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
                return;
            }
            if(!document.getElementById("subAgreement").checked)
            {
                showAlert(I18N.getMsg('letsencrypt.accept.agreement'));//NO I18N
                return;
            }
            var reg_uri = document.getElementById("URI").value;
            var params = '?account_name='+account_name+'&email='+email+'&reg_uri='+reg_uri;//NO I18N
            var ajaxRequestUrl = '/api/pki/letsencrypt/addNewAccount'+params; //No I18N
             fileData.append("pmpcp", Get_Cookie('pmpcc'));//NO I18N
            getAjaxApiRequestForFile(ajaxRequestUrl,fileData,browse,textfield,true,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        redirectUrl("LETSMgmt/LETSAccount"); //No I18N
                    }
            });
       }
    
    }
});

App.LETSMgmtLETSDeployFilterController = Ember.ObjectController.extend({
    needs:'LETSMgmtLETSDeploy',//NO I18N
    actions:{
       deleteMapping:function(){
            var app=this.get('controllers.LETSMgmtLETSDeploy');//NO I18N
            app.send('deleteMapping');//NO I18N
       }
   } 
});


App.LETSMgmtWAgentsController = Ember.ObjectController.extend({
   actions: {
       deleteAgents: function(){
            var grid = jQuery("#WAgentsTable"); //No I18N
            var agentIds="";
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('agents.delete.selectone')); //No I18N
                return;
            }
            vConfirmation(I18N.getMsg('agents.delete.confirm'),function(){//NO I18N
                $.each(selRowIds, function()
                {
                    var id = this;
                    var agentId = grid.jqGrid('getCell',id,'AGENT_ID');//NO I18N
                    if(agentIds!=="")
                    {
                        agentIds=agentIds+","+agentId;//NO i18N
                    }
                    else
                    {
                        agentIds=agentId;
                    }
                });
                var ajaxRequestUrl = '/api/pki/letsencrypt/deleteWagents'; //No I18N
                var params = 'agentIds='+agentIds;//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        App.Request.WAgents();
                        messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N
                    }
                });
            });
       }
   } 
});

App.LETSMgmtLETSDeployController = Ember.ObjectController.extend({
    actions : {        
        deleteMapping: function(){
            var grid = jQuery("#LetsEncryptDeploy"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var mapIds="";
            var domains="";
            var servers="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('deletemapping.select.one')); //No I18N
                return;
            }
            vConfirmation(I18N.getMsg('deletemapping.confirm'),function(){//NO I18N
                $.each(selRowIds, function()
                {
                    var id = this;
                    var mapId = grid.jqGrid('getCell', id, 'Mapping_ID'); //NO I18N   
                    var domain = grid.jqGrid('getCell',id,'Domain_Names');//NO I18N
                    var server = grid.jqGrid('getCell',id,'Server');//NO I18N
                    if(mapIds!=="")
                    {
                        mapIds=mapIds+","+mapId;
                        domains=domains+","+domain;
                        servers=servers+","+server;
                    }
                    else
                    {
                        mapIds=mapId;
                        domains=domain;
                        servers=server;
                    }
                });
                var ajaxRequestUrl = '/api/pki/letsencrypt/deleteDomainMappings'; //No I18N
                var params = 'mapIds='+mapIds+"&domains="+domains+"&servers="+servers+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        App.Request.letsEncryptDomainMappings(App.RequestCertController.domain);
                        messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N
                    }
                });
            });
        }
    }
});
