// $Id$
App.Request = Ember.Object.extend({});

var requestDetails = App.Request.create();

App.Request.reopenClass({
    agentsView: function(jsonData)
    {
      var challengeType = App.RequestCertController.challengeType;
      if(jsonData.dns_server!==undefined)
        {
            document.getElementById("dns_server").value=jsonData.dns_server.dns_server;
            var dnsDetails = jsonData.dns_server;
            fillDNSDetails(dnsDetails);
        }
      getDnsServersList();
      var agents = jsonData.Agents;
        if(agents.length>0)
        {
      for(var i=0;i<agents.length;i++)
      {
          var agentName = agents.get(i).AgentName;
          var agentIp = agents.get(i).AgentIP;
          var agentId = agents.get(i).AgentID;
          var option = new Option(agentName+" ( "+agentIp+" )",agentId);
          $("#Agents").append(option);
      }
            if(jsonData.select !== undefined)
            {
               $("#Agents option:contains("+jsonData.select+")").each(function(){
                      $(this).attr('selected', 'selected');
                 }); 
            }
        }
        else
        {
            document.getElementById("linux").checked=true;
            $("#windowsAgent").hide();
            $("#linuxAgent").show();
            document.getElementById("windows").disabled=true;
        }
        
        if(jsonData.challengeType!==undefined && jsonData.challengeType!=="")
      {
            challengeType = jsonData.challengeType;
        }
        if(challengeType!==undefined && challengeType==="dns-01")
        {
            jQuery('input[name=challenge_type]').attr('disabled',true);//NO I18N
            document.getElementById("dns").checked=true;
            chooseChallengeType("dns-01");//NO I18N
            $("#deploycertcheck").show();
            if(jsonData.deploycert!==undefined && jsonData.deploycert===false)
            {
                document.getElementById("deploy_certificate").checked = false;
                showDeployCertDetails();
            }            
        }
        else
        {
            document.getElementById("http").checked=true;
            chooseChallengeType("http-01");//NO I18N
        }
        
        if(challengeType!=undefined && challengeType==="http-01")
        {
            jQuery('input[name=challenge_type]').attr('disabled',true);//NO I18N
        }
        
        
        if(jsonData.AgentId!==undefined || jsonData.dns_server!==undefined)
        {
            $("#challengeTypeDiv").hide();
            if(jsonData.AgentId!==undefined)
            {
            if(jsonData.OsType === "Windows")
            {
                document.getElementById("windows").checked=true;
                $("#windowsAgent").show();
                $("#linuxAgent").hide();
          $("#Agents").val(jsonData.AgentId);
      }
            else
            {
                document.getElementById("linux").checked=true;
                $("#windowsAgent").hide();
                $("#linuxAgent").show();
                $("#serverName").val(jsonData.ServerName);
                $("#userName").val(jsonData.UserName);
                document.getElementById("password").placeholder="********";//NO I18N
            }
        }
            
            }
      if(jsonData.Path!== undefined)
      {
          $("#path").val(jsonData.Path);
      }
      
      if(jsonData.port!==undefined && jsonData.port!=="")
      {
          $("#port").val(jsonData.port);
      }
      else
      {
          $("#port").val("22");
      }
      if(jsonData.KeyPath!==undefined && jsonData.KeyPath!=="")
      {
            var cn="no";//NO I18N
            var kn="no";//NO I18N
            var sn="no";  //NO I18N
            if(jsonData.KeyPath!=="NA")
            {
          $("#keypath").val(jsonData.KeyPath);
            }
            if(jsonData.certFileName!==undefined)
      {
                if(jsonData.certFileName!=="no")
                {
          $("#certFileName").val(jsonData.certFileName);
      }
                cn=jsonData.certFileName;
            }
            if(jsonData.keyFileName!==undefined)
      {
                if(jsonData.keyFileName!=="no")
                {
          $("#keyFileName").val(jsonData.keyFileName);
      }
                kn=jsonData.keyFileName;
            }
            if(jsonData.storeFileName!==undefined)
      {
                if(jsonData.storeFileName!=="no")
                {
          $("#storeFileName").val(jsonData.storeFileName);
      }
                sn=jsonData.storeFileName;
            }
            checkPushOptions(cn,kn,sn);
      }        
      
if(App.RequestCertController.edit)
      {
          $("#domainName").val(App.RequestCertController.sdomain);
          document.getElementById("domainName").disabled=true;
      }
      if(App.RequestCertController.domain!== "all")
      {          
            var domain = App.RequestCertController.domain;
            $("#domainName").val(domain);
            document.getElementById("domainName").disabled=true;   
      }
      
      var path = document.URL;
      if(path.indexOf("LETSMgmt")==-1)
      {
          $("#ManageLink").show();
      }
      else 
      {
          $("#ManageLink").hide();
      }
    },
    deployStatus: function(jsonData,challengeType)
    {
        var hide = false;
        if(challengeType==="dns-01")
        {
            hide=true;
        }
        var colNamesList= [I18N.getMsg('js.sslcertificate.domainname'),I18N.getMsg('js.radius.ipaddress'),I18N.getMsg('js.commonstr.status'),'','','','','',''];//NO I18N
        var colModelList = [
            {name:'domain',index:'domain',width:'200'},//NO I18N
            {name:'agentName',index:'agentName',width:'300',hidden:hide},//NO I18N
            {name:'status',index:'status',width:'100'},//NO I18N
            {name:'challengeId',index:'challengeId',hidden:true},//NO I18N
            {name:'challengeType',index:'challengeType',hidden:true},//NO I18N
            {name:'dns_server',index:'dns_server',hidden:true},//NO I18N
            {name:'agentId',index:'agentId',hidden:true},//NO I18N
            {name:'osType',index:'osType',hidden:true},//NO I18N
            {name: 'deploy',index:'deploy',formatter:'deployChallengeFormatter',fixed:true,width:'50'}//NO I18N
        ];
        var defaultOptions={multiselect:false,rowNumNeeded:false,searchOption:true};
        loadJQgridWithData("#LetsEncryptDeployStatus", jsonData.deployList, colNamesList, colModelList, "", "","DeployStatus",defaultOptions, "#LetsEncryptDeployStatusPager");//No I18N  
        var DataGrid = $('#LetsEncryptDeployStatus');
        DataGrid.jqGrid('setGridWidth', '460');//No I18N
        DataGrid.jqGrid('setGridHeight', '250');//No I18N
    },
    letsEncryptRequestsChallenges: function(req_id){
        var ajaxRequestUrl = '/api/pki/letsencrypt/getRequestChallenges'; //No I18N
        var params = "req_id="+req_id;//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            App.Request.showChallenges(jsonData);
        });
    },
    letsEncryptRequestsHistory: function(req_id)
    {
        var ajaxRequestUrl = '/api/pki/letsencrypt/getRequestHistory'; //No I18N
        var params = "req_id="+req_id;//NO I18N
        getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            var colNamesList = ['VersionId',I18N.getMsg('js.sslcertificate.domainnames'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.report.timeline.todate'),I18N.getMsg('js.sslrequest.processedby'),I18N.getMsg('js.revoked.title'),I18N.getMsg("js.revoked.by"),I18N.getMsg('js.table.search')];//NO I18N
            var colModelList = [
                {name:'VERSION_ID',index:'VERSION_ID',hidden:true},//NO I18N
                {name:'DOMAIN',index:'DOMAIN'},//NO I18N
                {name:'VALID_FROM',index:'VALID_FROM'},//NO I18N
                {name:'VALID_TO',index:'VALID_TO'},//NO I18N
                { name: 'CLOSEDBY', index: 'CLOSEDBY'}, //No I18N
                {name:'CERT_STATUS',index:'CERT_STATUS'},//NO I18N
                { name: "REVOKED_BY",index:"REVOKED_BY"},//NO I18N
                { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#historyList", jsonData.historyList, colNamesList, colModelList, "", "#historyListPager", "LetsEncryptHistory",defaultOptions);//No I18N     
        });        
    },
    letsEncryptRequestsList: function(){
        var ajaxRequestUrl = '/api/pki/letsencrypt/getRequestsList'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['RequestId','','',I18N.getMsg('js.sslcertificate.domainnames'),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.report.timeline.todate'),I18N.getMsg('js.sslrequest.requestername'),I18N.getMsg('lets.encrypt.authorizedby'),I18N.getMsg('js.sslrequest.processedby'),I18N.getMsg('request.status'),I18N.getMsg("certificate.status"),'','','','',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'REQUEST_ID', index: 'REQUEST_ID',hidden:true},//No I18N
                    { name: 'CERTIFICATE', index: 'CERTIFICATE',hidden:true},//NO I18N
                    { name: 'CHALLENGETYPE', index: 'CHALLENGETYPE',hidden:true},//NO I18N
                    { name: 'DOMAINS', index: 'DOMAINS',formatter:'letsencryptCertificateFormatter',width:"250px"}, //No I18N
                    { name: 'VALID_FROM', index:'VALID_FROM',width:"100px"},//NO I18N
                    { name: 'VALID_TO', index:'VALID_TO',width:"100px"},//NO I18N
                    { name: 'USERNAME', index: 'USERNAME',width:"120px"}, //No I18N
                    { name: 'AUTHORIZEDBY' , index:'AUTHORIZEDBY',width:"120px"},//NO I18N
                    { name: 'CLOSEDBY', index: 'CLOSEDBY',width:"120px"}, //No I18N
                    { name: 'STATUS', index: 'STATUS',formatter:'letsencryptStatusFormatter',width:'100px'}, //No I18N
                    { name: "CERT_STATUS",index:'CERT_STATUS',formatter:'certStatusFormatter',width:'115px'},//NO I18N
                    { name: 'AUTHORIZATION' ,index:'AUTHORIZATION' ,hidden:true},//NO I18N
                    { name: 'History', index:'History',formatter:'letsCertHistoryFormatter',width:'30px',fixed:true},//NO I18N
                    { name: 'showPassPhrase',index: 'showPassPhrase',formatter:'showLetsEncryptPasswordFormatter',width:'30px',align:'center',search:false,fixed:true},//NO I18N
                    { name: 'deploy',index:'deploy',formatter:'deployCertificateFormatter',fixed:true,width:'50',hidden:true},//NO I18N
                    { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PendingCertList", jsonData.requestList, colNamesList, colModelList, "", "#ListPager", "LetsEncryptList",defaultOptions);//No I18N                    
            });        
    },
    godaddyRequestsList: function(){
        var ajaxRequestUrl = '/api/pki/godaddy/getGodaddyRequestsList'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['RequestId',I18N.getMsg('js.commonstr.certificatename'),I18N.getMsg("godaddy.order.certtype"),I18N.getMsg('js.report.timeline.fromdate'),I18N.getMsg('js.report.timeline.todate'),I18N.getMsg('js.sslrequest.requestername'),I18N.getMsg('lets.encrypt.authorizedby'),'','','',I18N.getMsg("js.commonstr.status"),'','','',I18N.getMsg('js.table.search')]; //No I18N
            var colModelList = [
                    { name: 'ID', index: 'ID',hidden:true},//No I18N                    
                    { name: 'CommonName', index: 'CommonName',classes:"pointer"}, //No I18N
                    { name: 'CertType' , index: 'CertType'},//NO I18N
                    { name: 'ValidFrom', index:'ValidFrom',width:"100px"},//NO I18N
                    { name: 'ValidTo', index:'ValidTo',width:"100px"},//NO I18N
                    { name: 'UserName', index: 'UserName',width:"120px"}, //No I18N  
                    { name: 'AUTHORIZEDBY' , index:'AUTHORIZEDBY',width:"120px",hidden:true},//NO I18N
                    { name: 'Order_Status',index:'Order_Status',hidden:true},//NO I18N
                    { name: "CERT_STATUS",index:'CERT_STATUS',hidden:true},//NO I18N
                    { name: 'AUTHORIZATION' ,index:'AUTHORIZATION' ,hidden:true},//NO I18N
                    { name: 'STATUS', index: 'STATUS',formatter:'godaddyCertStatusFormatter',width:'150px',search:true},//NO I18N
                    { name: 'History_Status',index:'History_Status',hidden:true},//NO I18N
                    { name: 'History', index:'History',formatter:'godaddyHistoryFormatter',width:'30px',fixed:true,search:false},//NO I18N
                    { name: 'showPassPhrase',index: 'showPassPhrase',formatter:'showGoDaddyPasswordFormatter',width:'30px',align:'center',search:false,fixed:true,hidden:true},//NO I18N
                    { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};       
            loadJQgridWithData("#PendingCertList", jsonData.requestList, colNamesList, colModelList, "", "#ListPager", "GoDaddyRequestsList",defaultOptions);//No I18N                    
        });
    },
    letsEncryptDomainMappings: function(domain){
        var ajaxRequestUrl = '/api/pki/letsencrypt/getDomainMappings'; //No I18N
        var params = "domain="+domain;//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
            var colNamesList = ['MAPPING_ID',"AGENT_ID",I18N.getMsg('js.sslcertificate.domainname'),I18N.getMsg("letsencrypt.challengetype"),'',I18N.getMsg('js.general.username'),'',I18N.getMsg('js.table.search')];//NO I18N
            var colModelList = [
                { name:'Mapping_ID', index: 'Mapping_ID',hidden:true },//NO I18N  
                { name: 'Agent_ID', index: 'Agent_ID', hidden:true},//NO I18N
                { name:'Domain_Names', index: 'Domain_Names' },//NO I18N
                { name: 'ChallengeType',index:'ChallengeType'},//NO I18N   
                { name: 'dns_server',index:'dns_server',hidden:true},//NO I18N   
                { name: 'User_Name', index: 'User_Name' },//NO I18N
                { name: 'EditMapping',index:'EditMapping',formatter:'editFormatter',width:'30px',align:'center',search:false,fixed:true},//NO I18N
                { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N     
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#LetsEncryptDeploy", jsonData.mapList, colNamesList, colModelList, "", "#LetsEncryptDeployPager", "LetsEncryptDeployMapping",defaultOptions);//No I18N                
        });
    },
    showChallenges: function(jsonData){        
        var colNamesList;
        var hide=false;
        if(jsonData.challengeType==="http-01")
        {
            colNamesList = ['ChallengeId',I18N.getMsg('js.sslcertificate.domainname'),I18N.getMsg('letsencrypt.challengetype'),I18N.getMsg('letsencrypt.challenge.filecontent'),I18N.getMsg('letsencrypt.challenge.filepath'),"",I18N.getMsg('js.general.creationtime'),'',I18N.getMsg('js.commonstr.status'),'','','','',I18N.getMsg('js.table.search')]; //No I18N
        }
        else
        {
            hide=true;
            colNamesList = ['ChallengeId',I18N.getMsg('js.sslcertificate.domainname'),I18N.getMsg('letsencrypt.challengetype'),I18N.getMsg('letsencrypt.dnsvalue'),I18N.getMsg('letsencrypt.txtrecord'),"",I18N.getMsg('js.general.creationtime'),'',I18N.getMsg('js.commonstr.status'),'','','','',I18N.getMsg('js.table.search')]; //No I18N
        }
         
            var colModelList = [
                    { name: 'challengeId', index: 'challengeId',hidden:true},//No I18N
                    { name: 'domain', index: 'domain',width:"70px"}, //No I18N
                    { name: 'challengeType', index: 'challengeType',width:"50px"},//NO I18N
                    { name: 'challengeContent', index: 'challengeContent'},//NO I18N
                    { name: 'challengeContentPath', index: 'challengeContentPath'},//NO I18N
                    { name: 'token',index: 'token',hidden:true},//NO I18N
                    { name: 'creationTime', index:'creationTime',width:"60px"},//NO I18N                    
                    { name: 'status', index: 'status' , hidden:true},//NO I18N                    
                    { name: 'challengeStateFormatter', index: 'challengeStateFormatter',width:"50px",formatter:'challengeStateFormatter'}, //No I18N
                    { name: 'newRequestFormatter',index:'newRequestFormatter',formatter:'newRequestFormatter',width:'35px',fixed:true},//NO I18N
                    { name: 'Download' , index: 'Downlaod',formatter:'challengeDownlaodFormatter',width:"35px",fixed:true,hidden:hide},//NO I18N
                    { name: 'agentFormatter',index:'agentFormatter',formatter:'agentFormatter',width:"35px",fixed:true},//NO I18N
                    { name: 'deployStatus',index:'deployStatus',formatter:'deployStatusFormatter',width:"35px",fixed:true},//NO I18N
                    { name: 'search',width:40,sortable: false,search:false,fixed:true}//NO I18N
                ];
            var defaultOptions={rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#requestChallenges",jsonData.challenges, colNamesList, colModelList, "", "#challengesListPager", "LetsEncryptChallenges",defaultOptions);//No I18N             
           
    },
    defaultDNSServers: function(){
      var ajaxUrl = '/api/pki/letsencrypt/getGlobalDNS';//NO I18N
        getAjaxApiRequest(ajaxUrl,"", function(jsonData) {
            var colNamesList = ['ID',I18N.getMsg("dns.provider"),I18N.getMsg("js.letsencrypt.Account"),I18N.getMsg("js.commonstr.status"),'',I18N.getMsg('js.table.search')];//NO I18N
            var colModelList = [
                {name:'ID',index:'ID',hidden:true},//NO I18N
                {name:'Provider',index:'Provider'},//NO I18N
                {name:'Account',index:'Account'},//NO I18N
                {name:'Status',index:'Status'},//NO I18N
                { name: 'Edit', index: 'Edit',search:false,formatter:'editFormatter',width:'30px',fixed:true}, //No I18N
                { name: 'search',width:'40px',sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PKILetsEncrypt", jsonData.AccountList, colNamesList, colModelList, "", "#PKILetsEncryptPager", "DefaultDNSServer",defaultOptions);//No I18N
        });  
    },
    listLetsEncryptAccounts: function(){
        var ajaxRequestUrl = '/api/pki/letsencrypt/getAccounts'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['Account Id',I18N.getMsg("js.letsencrypt.accountname"),I18N.getMsg("js.general.createdby"),I18N.getMsg("js.createUser.Email-id"),I18N.getMsg("js.letsencrypt.uri"),'',I18N.getMsg('js.table.search')];//NO I18N
            var colModelList = [
                {name: 'ACCOUNT_ID', index:'ACCOUNT_ID', hidden:true},//NO I18N
                {name: 'ACCOUNT_NAME', index:'ACCOUNT_NAME'},//NO I18N
                {name: "USERNAME",index:"USERNAME"},//NO I18N
                {name: 'EMAIL',index:'EMAIL'},//NO I18N
                {name: 'URI', index:'URI'},//NO I18N
                { name: 'Export', index: 'Export',formatter:'exportKeyFormatter',width:'30px',align:'center',search:false,fixed:true}, //No I18N
                { name: 'search',width:'40px',sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#PKILetsEncrypt", jsonData.AccountList, colNamesList, colModelList, "", "#PKILetsEncryptPager", "LetsEncryptAccount",defaultOptions);//No I18N
        });
    },
    WAgents: function(){
        var ajaxRequestUrl = '/api/pki/letsencrypt/getWAgentsList'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
            var colNamesList = ['AGENT_ID',I18N.getMsg('js.discovery.hostname'),I18N.getMsg('js.discovery.ipaddress'),I18N.getMsg('js.mailserverSetting.MailAccountUserName'),I18N.getMsg('agents.general.installedtime'),I18N.getMsg('js.table.search')];//NO I18N
            var colModelList = [
                {name:'AGENT_ID',index:'AGENT_ID',hidden:true},//NO I18N
                {name:'AGENT_NAME',index:'AGENT_NAME'},//NO I18N
                {name:'IPADDRESS',index:'IPADDRESS'},//NO I18N
                {name:'USER_NAME',index:'USER_NAME'},//NO I18N
                {name:'TIME',index:'TIME'},//NO I18N
                { name: 'search',width:'40px',sortable: false,search:false,fixed:true}//NO I18N
            ];
            var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
            loadJQgridWithData("#WAgentsTable", jsonData.agentsList, colNamesList, colModelList, "", "#WAgentsPager", "WAgents",defaultOptions);//No I18N
        });
    },
    getResourceNames: function(eltSelect) {
        var ajaxRequestUrl = '/api/pki/request/getCSRCnames'; //No I18N
        getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
            for(var key in jsonData){
                var sub_val = jsonData[key];
                $("#CNames").append("<option value='"+key+"' selected>"+sub_val+"</option>");
            }
        });
        ajaxRequestUrl = '/api/pki/request/getCertificateNames'; //No I18N
        var reqParams="res_type=ssl";//No I18N
            getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                    var arr=new Array();
                    arr=jsonData.CertList;
                    var content="";//No I18N
                        for(var i=0;i<arr.length;i++)
                        {
                            if(eltSelect===arr[i].ResourceName)
                            {
                                $("#PARENTNAME").append("<option value='"+arr[i].ResourceName+"' selected>"+arr[i].ResourceName+"</option>");
                            }
                            else
                            {
                                $("#PARENTNAME").append("<option value='"+arr[i].ResourceName+"' >"+arr[i].ResourceName+"</option>");
                            }
                        }
            });
    },
    getRequestList: function(controller) {
        var ajaxRequestUrl = '/api/pki/request/RequestList'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                        var colNamesList = ['RequestId',I18N.getMsg('js.sslrequest.newdomain'),I18N.getMsg('js.sslrequest.parentdomain'),I18N.getMsg('js.sslrequest.startdate'),I18N.getMsg('js.sslrequest.closeddate'),I18N.getMsg('js.sslrequest.requestername'),I18N.getMsg('js.sslrequest.processedby'),I18N.getMsg('js.commonstr.status'),I18N.getMsg('js.table.search')]; //No I18N
                        var colModelList = [
                                { name: 'REQUESTID', index: 'REQUESTID',hidden:true}, //No I18N
                                { name: 'SubDomain', index: 'SubDomain',formatter:'requestNameFormatter'}, //No I18N
                                { name: 'ParentDomain', index: 'ParentDomain'}, //No I18N
                                { name: 'StartDate', index: 'StartDate'}, //No I18N
                                { name: 'ClosedDate', index: 'ClosedDate'}, //No I18N
                                { name: 'Requested By', index: 'Requested By'}, //No I18N
                                { name: 'Processed By', index: 'Processed By'}, //No I18N
                                { name: 'Status', index: 'Status',formatter:'requestStatusFormatter'}, //No I18N
                                { name: 'search',width:"40px",sortable: false,search:false,fixed:true}//NO I18N
                        ];
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#PKIRequestList", jsonData.REQ_LIST, colNamesList, colModelList, "", "#PKIRequestListPager","RequestState" ,defaultOptions);//No I18N                        
                    if(controller!=undefined)
                    {
                        var dig_arr=null;
                        var placeHolder=null;
                        if(App.ApplicationController.isAdmin===true)
                        {
                        var dig_arr=new Array('showDetailsDialog','showReqCloseDialog');
                        var placeHolder=new Array('.reqsName','.reqClose');
                        }
                        else
                        {
                            var dig_arr=new Array('showDetailsDialog');
                            var placeHolder=new Array('.reqsName');
                        }
                        openDialogInTable(controller,"#PKIRequestList",placeHolder,dig_arr);//No I18N    
                    }
            });
    },
    getGeneratedCerts: function(controller) {
        var ajaxRequestUrl = '/api/pki/request/getGeneratedCerts'; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                  var wid='30px';//No I18N
                    if (window.userRole != "Administrator") {
                      wid='0px';//No I18N
                    }
                        var colNamesList = ['NEWCERTId',I18N.getMsg('js.sslcertificate.domainname'),I18N.getMsg('js.general.createdby'),I18N.getMsg('js.general.creationtime'),I18N.getMsg('js.ssl.certificate.validity'),I18N.getMsg('js.ssl.certificate.keyalgorithm'),I18N.getMsg('js.keystore.type'),'','','','',I18N.getMsg('js.table.search')]; //No I18N
                        var colModelList = [
                                { name: 'NEWCERTID', index: 'NEWCERTID',hidden:true}, //No I18N
                                { name: 'DOMAIN_NAME', index: 'DOMAIN_NAME',formatter:'requestNameFormatter'}, //No I18N
                                { name: 'CREATED_BY', index: 'CREATED_BY'}, //No I18N
                                { name: 'CREATED_DATE', index: 'CREATED_DATE'}, //No I18N
                                { name: 'VALIDITY', index: 'VALIDITY'}, //No I18N
                                { name: 'KEYALGORITHM', index: 'KEYALGORITHM'}, //No I18N
                                { name: 'KEYSTORE_TYPE', index: 'KEYSTORE_TYPE'},//NO I18N
                                { name: 'showPassPhrase',index: 'showPassPhrase',formatter:'showPasswordFormatter',width:'30px',align:'center',search:false,fixed:true},//NO I18N
                                { name: 'Import', index: 'Import',formatter:'importCertFormatter',width:wid,align:'center',search:false,fixed:true}, //No I18N
                                { name: 'Export', index: 'Export',formatter:'exportKeyFormatter',width:'30px',align:'center',search:false,fixed:true,value:'ExportCSR'}, //No I18N
                                { name: 'EMAIL', index: 'EMAIL',formatter:'eMailFormatter',width:'30px',align:'center',search:false,fixed:true}, //No I18N
                                { name: 'search',width:"40px",sortable: false,search:false,fixed:true}//NO I18N
                        ];
                    var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                    loadJQgridWithData("#CreatedCertList", jsonData.GeneratedList, colNamesList, colModelList, "", "#ListPager","GeneratedCertList" ,defaultOptions);//No I18N                        
                    if(controller!=undefined)
                    {
                        var dig_arr=new Array('showCertDetailsDialog','showmailCSRDetailsDialog','showImportCertDialog');
                        var placeHolder=new Array('.reqsName','.mailcsrContent','.icon-import');
                        openDialogInTable(controller,"#CreatedCertList",placeHolder,dig_arr);//No I18N    
                    }
            });
    },
    getRequestDetails: function(req_id) {
        var ajaxRequestUrl = '/api/pki/request/getrequest?REQ_ID='+req_id; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    //App.Request.getResourceNames(jsonData.PAR_DOMAIN);
                    $('#req_Name').text(jsonData.REQUESTER);
                    $('#domain_Name').text(jsonData.INC_DOMAIN);
                    if(jsonData.REQUEST_TYPE=='New_Domain')
                    {
                        $("#req_type").text(I18N.getMsg("js.sslcert.request.newCertificate"));//No I18N    
                        if(jsonData.CSR_CONTENT!=undefined && jsonData.CSR_CONTENT!="")
                        {
                            $("#CSR_CONTENT").text(jsonData.CSR_CONTENT);
                        }
                        else
                        {
                            $("#CSRCONTENT").hide();
                        }
                    }
                    else
                    {
                        $("#req_type").text(I18N.getMsg("js.sslcert.request.domainAddition"));//No I18N    
                        $("#parent_name").text(jsonData.PAR_DOMAIN)
                        $("#PARENTDOMAIN").show();
                        $("#CSRCONTENT").hide();
                    }
                    $('#mail_id').text(jsonData.MAIL_ID);
                    $('#no_of_year').text(jsonData.NO_OF_YEARS);
                    $('#annotation').text(jsonData.NOTES);
                    if(jsonData.DEVICE_NAME!=undefined && jsonData.DEVICE_NAME!="")
                    {
                        $("#deviceNameDIV").show();
                        $('#deviceName').text(jsonData.DEVICE_NAME);
                    }
                    if(jsonData.IP_ADDRESS!=undefined && jsonData.IP_ADDRESS!="")
                    {
                         $("#ipaddressDIV").show();
                        $('#ipaddress').text(jsonData.IP_ADDRESS);
                    }
                    if(jsonData.PROCESSED_BY!=undefined)
                    {
                        $('#processed_by').text(jsonData.PROCESSED_BY);
                    }
                    else
                    {
                        $('#processed_by').text("-");//No I18N    
                    }
                    if(jsonData.STATUS==true)
                    {
                        $('#status').text("Closed");//No I18N    
                    }
                    else
                    {
                        $('#status').text("Inprogress");//No I18N    
                    }
                    requestDetails.setProperties(jsonData);
        });
        return requestDetails;
    },
    getSSLMgmtTabList: function() {
        if(kmpStandAlone){
    	var selectedTab = App.RequestCertController.selectedTab;
        var add = false;
        var crt = false;
        var req = false;
        var crts = false;
        var lets = false;
        var godaddy=false;
        var availableTopViews= topview.SSL;
        if (selectedTab === "crts") {
            crts = true;
        } 
        else if (selectedTab === "add") {
            add = true;
        } 
        else if (selectedTab === "crt") {
            crt = true;
        } 
        else if (selectedTab === "req") {
            req = true;
        } 
        else if (selectedTab === "lets") {
            lets = true;
        }
        else if (selectedTab === "godaddy"){
            godaddy=true;
        }

        var baseurl = window.apiclientUrl + "SSLMgmt/"; //No I18N
        var arr = new Array();
        var jsonObj = {
        }
        if (availableTopViews.indexOf("Certificates") > -1)
        {
            var object = {"Name": I18N.getMsg("js.sslmgmt.certificates"), "url": baseurl + "SSL", "title": "SSL Certificates", "isSelected": crts, "image": false}; //No I18N
            arr.push(object);
        }
        if (availableTopViews.indexOf("CreateCSR") > -1)
        {
            var object = {"Name": I18N.getMsg("js.create.csr"), "url": baseurl + "CreateCertificateList", "title": "Create New Csr", "isSelected": crt, "image": false}; //No I18N
            arr.push(object);
        }
        if (availableTopViews.indexOf("CertificateRequests") > -1)
        {
            var object = {"Name": I18N.getMsg("js.sslcert.certificateRequest"), "url": baseurl + "Request/List", "title": "Certificate Request", "isSelected": req, "image": false}; //No I18N
            arr.push(object);
        }
        if (availableTopViews.indexOf("LetsEncrypt") > -1)
        {
            var imagetag='<img src="../../images/le-logo-lockonly18.png"/>';//NO I18N
            var object = {"Name": I18N.getMsg("js.rolename.LETS_ENCRYPT"), "url": baseurl + "LetsEncryptRequestList", "title": "Let's Encrypt", "isSelected": lets, "image": true , "imagelocation":imagetag};//NO I18N
            arr.push(object);
        }
        if (availableTopViews.indexOf("GoDaddy") > -1 && App.ApplicationController.isAdmin)
        {
            var imagetag='<svg style="margin-top:9px" id="Layer_1" height="18" width="18" data-name="Layer 1"  viewBox="0 0 68.81 103.06"><path id="_Path_" data-name="&lt;Path&gt;" d="M29.9,10.17a3.91,3.91,0,0,1,0-.49c-.05-2.41,2.24-5,2.31-7.73h0V1.88A1.1,1.1,0,0,0,31.51,1,2.72,2.72,0,0,0,30.34.73a3.69,3.69,0,0,0-3.05,1.46C26.16,4.55,24.37,7,24.35,9.59A4.44,4.44,0,0,0,25,12c1,2.18,2.32,4.13,3.36,6.47a2.71,2.71,0,0,1-.61,3.15c-.17.23-1.3.18-1.87,1.12l0,.06v.06a1.47,1.47,0,0,0,0,.36,2.17,2.17,0,0,0,1.6,1.91,3.71,3.71,0,0,0,1.39.26,4.81,4.81,0,0,0,4-2.31,5.49,5.49,0,0,0,.8-2.85c-.06-3.64-3.29-6.83-3.68-10.06" transform="translate(-0.75 -0.13)" style="fill:#ec6d23"/><path id="_Path_2" data-name="&lt;Path&gt;" d="M43.19,14.6A31.07,31.07,0,0,1,40,9.48a4.8,4.8,0,0,1-.69-2.06,2.93,2.93,0,0,1,1.16-2.19,2.56,2.56,0,0,0,.72-2,3.18,3.18,0,0,0-1-2.45,3.46,3.46,0,0,0-1.9-.7c-1.25,0-2,1-2.61,2.11a29,29,0,0,0-1.47,4A5.48,5.48,0,0,0,34,7.92c.06,4.16,4.51,7.4,5.49,11.25a3.91,3.91,0,0,1,.17,1.15,8.55,8.55,0,0,1-.7,2.89,2.48,2.48,0,0,0-.17.86A2,2,0,0,0,40.9,26h0a2.24,2.24,0,0,0,1.62-.66c2.1-2.17,2.9-4,2.9-5.64,0-2.08-1.24-3.65-2.24-5.1" transform="translate(-0.75 -0.13)" style="fill:#ec6d23"/><path id="_Path_3" data-name="&lt;Path&gt;" d="M6.55,14.24a5.65,5.65,0,0,1-.48-2.54c0-1.25.21-2.6.21-3.9A6.22,6.22,0,0,0,6,5.68,1.18,1.18,0,0,0,4.79,5,3.7,3.7,0,0,0,1.44,7.47a55.43,55.43,0,0,0-.69,5.61,5.77,5.77,0,0,0,1.79,4.38c2,1.92,4.14,3.44,5.34,5.13a3.31,3.31,0,0,1,.77,1.83,3.45,3.45,0,0,1-.29,1.3A9.51,9.51,0,0,0,7,28.41v.13a.9.9,0,0,0,.78.84H7.9c.46,0,.79-.19,1.17-.19h.29a4.46,4.46,0,0,0,4.22-3.57,5.78,5.78,0,0,0,.11-1.14c-.09-4.62-5.48-6.81-7.14-10.24" transform="translate(-0.75 -0.13)" style="fill:#ec6d23"/><path id="_Path_4" data-name="&lt;Path&gt;" d="M20.08,13.37C18.36,10.52,16,8,15.76,5.17c0,0,0,0,.1-.08a18.26,18.26,0,0,1,2.31-.74,6.91,6.91,0,0,0,1.7-.74c.54-.35,1.1-.7,1.15-1.44a1.07,1.07,0,0,0-.49-.87A5.66,5.66,0,0,0,17.59.52c-3,0-6.23,2-7,4.95a5.81,5.81,0,0,0-.17,1.35c.08,4.33,4.92,7.36,6.15,11.25v0a4,4,0,0,1,.24,1.38,9.82,9.82,0,0,1-.53,2.69,1.87,1.87,0,0,0-.1.62A1.38,1.38,0,0,0,16.86,24a2.45,2.45,0,0,0,1.32.34,3.48,3.48,0,0,0,2.48-1,6.45,6.45,0,0,0,1.41-4.06,11.79,11.79,0,0,0-2-5.94" transform="translate(-0.75 -0.13)" style="fill:#ec6d23"/><path id="_Path_5" data-name="&lt;Path&gt;" d="M53.45,88.72h-.19" transform="translate(-0.75 -0.13)" style="fill:#22201f"/><path d="M66,48.63A16.82,16.82,0,0,0,58.29,47h-.1C55.46,40.13,52,35,47.88,31.8a31.42,31.42,0,0,0-19.51-6.21,45.78,45.78,0,0,0-11.44,1.57c-.28-.73-.55-1.47-.88-2.14A.71.71,0,0,0,15,24.8a1.61,1.61,0,0,0-.45,1.54,5.64,5.64,0,0,1,.07,1.48,52,52,0,0,0-6.35,2.37l-1.07.5a.8.8,0,0,0-.45.92l1.35,5.68c-.59.53-1.17,1.08-1.8,1.55s-.63,1.62-.16,1.76A12.69,12.69,0,0,0,9,41l1.39,5.87-.06.17c-.16.39-.4.79-.53,1.1-.33.72.3,1.56.68,1.34.16-.1.3-.23.45-.33l1.53,6.45a12.14,12.14,0,0,0-2.9,2.77,7.66,7.66,0,0,0-1.38,4.46,5.93,5.93,0,0,0,.5,2.51s0,.06.07.09a8.58,8.58,0,0,0-.53,3c0,.41,0,.83.06,1.27a6.38,6.38,0,0,0,3.41,5.07,12.82,12.82,0,0,0,5.66,1.44l6.24,26.35a.84.84,0,0,0,.46.56,1,1,0,0,0,.33.07.87.87,0,0,0,.39-.1l1.65-.91a77.59,77.59,0,0,0,7.1-4.43,5.64,5.64,0,0,1,3.44-1.09,15.85,15.85,0,0,1,3.77.71,25,25,0,0,0,6.4,1.07,14.35,14.35,0,0,0,3.12-.35,8.73,8.73,0,0,0,6-4.35,10.56,10.56,0,0,0,1.15-4.89c0-.51,0-.89-.06-1.14-.06-2.58-1.42-5.3-2.74-7.94l-.42-.85c-2.27-4.36-2.71-6-2.67-6.58a.31.31,0,0,0,0-.12,20,20,0,0,1,5.15-1.76c1.21-.3,2.35-.6,3.29-.9a7.5,7.5,0,0,0,1.36-.6,3,3,0,0,0,.84-.66,2.62,2.62,0,0,0,.67-1.72,43,43,0,0,0-.9-7.08A14.88,14.88,0,0,0,66,58.17c2-1,3.56-2.65,3.59-4.77S68,49.68,66,48.63M10.54,62.71a5.17,5.17,0,0,1,.87-2.92A12.18,12.18,0,0,1,13,58.11l.59,2.49a12.34,12.34,0,0,0-3.06,2.11" transform="translate(-0.75 -0.13)" style="fill:#121212"/><path id="_Path_6" data-name="&lt;Path&gt;" d="M13.63,46.72c.49-.59,1-1.26,1.57-2l.12-.17c.53-.7,1.13-1.49,1.73-1.49h.06a9.18,9.18,0,0,1,4.35,2c.38.27.78.54,1.21.81l.77.56a4.28,4.28,0,0,0,2.43,1.14h0l.37,0h0c.28,0,.44-.3.6-.62a3,3,0,0,1,.29-.46l0,0v0a1,1,0,0,0-.18-.88.37.37,0,0,1-.06-.1c-.13-.25-.24-.49-.34-.71a11.32,11.32,0,0,0-1.31-2.26c-.71-.92-1.38-1.83-2-2.7-.36-.5-.73-1-1.11-1.5a8.82,8.82,0,0,1,2.77-1.32c.46-.15.93-.31,1.39-.5A1.32,1.32,0,0,0,26.83,35a1.14,1.14,0,0,0-.51-.72l0,0h0a10.31,10.31,0,0,1-3.18-.82,8.32,8.32,0,0,0-1.68-.15A5.4,5.4,0,0,1,19.13,33c-.35-.16-.47-.73-.58-1.23,0-.14-.06-.28-.09-.4s-.15-.53-.24-.79-.07-.23-.1-.35a42.55,42.55,0,0,1,10.25-1.36,28.16,28.16,0,0,1,17.52,5.54c3.4,2.64,6.37,6.93,8.82,12.73a14.82,14.82,0,0,0-4.15,1.26,6.77,6.77,0,0,0-3.1,2.86c-.22,0-.43,0-.62-.05a9.89,9.89,0,0,0-1.63.19c-1-4.06-5.19-7-10.15-7-5.3,0-9.68,3.32-10.26,7.74a28.67,28.67,0,0,0-9.47,1.78Z" transform="translate(-0.75 -0.13)" style="fill:#fff"/><path id="_Path_7" data-name="&lt;Path&gt;" d="M10.33,32.79c1.09-.47,2.2-.88,3.25-1.24-.14.44-.28.87-.39,1.29a2,2,0,0,1-.5.52l-.21.17V34a14.52,14.52,0,0,1-1.6,1.16Z" transform="translate(-0.75 -0.13)" style="fill:#fff"/><path id="_Path_8" data-name="&lt;Path&gt;" d="M16,56.55a26.82,26.82,0,0,1,9-1.73c1,4,5.23,6.88,10.13,6.89,5.18,0,9.56-3.27,10.24-7.59h0a8,8,0,0,1,1.53-.21h.1a5.93,5.93,0,0,0,3.63,4.55A17.68,17.68,0,0,0,58.29,60h.34a43,43,0,0,1,.86,6.25,25.54,25.54,0,0,1-3.31,1l0,0c-2.6.67-5.54,1.43-6.93,2.63-2.27,2-.21,6.07,2,10.38a40,40,0,0,1,2.43,5.42c-4.8-.71-8-2-10.67-4.14s-4.68-5.15-7.13-8.68a1.6,1.6,0,0,0-1.32-.68,1.58,1.58,0,0,0-.91.28,1.55,1.55,0,0,0-.67,1,1.59,1.59,0,0,0,.26,1.21l.15.21c2.5,3.6,4.65,6.71,7.58,9.13,3.16,2.59,7.08,4.13,12.34,4.84l.88.11a5.67,5.67,0,0,1-4.62,6,10.42,10.42,0,0,1-2.28.24,22.1,22.1,0,0,1-5.5-.89,19.28,19.28,0,0,0-4.95-.86,8.68,8.68,0,0,0-5.22,1.72c-.93.64-3.06,2.1-5.6,3.57Z" transform="translate(-0.75 -0.13)" style="fill:#fff"/><path id="_Path_9" data-name="&lt;Path&gt;" d="M16.49,73.54a9.07,9.07,0,0,1-3.56-1.06,3.65,3.65,0,0,1-2.11-3c0-.43-.05-.76-.05-1A4.94,4.94,0,0,1,12,64.9a8.34,8.34,0,0,1,2.1-1.61Z" transform="translate(-0.75 -0.13)" style="fill:#fff"/><path id="_Path_10" data-name="&lt;Path&gt;" d="M58.28,57.29A15.24,15.24,0,0,1,51.79,56c-1.46-.74-2.2-1.62-2.2-2.61s.74-1.86,2.2-2.61a12.85,12.85,0,0,1,4.09-1.1,19,19,0,0,1,2.37-.17h0c.17,0,.32,0,.48,0l.3,0a14.24,14.24,0,0,1,5.7,1.33c1.67.87,2.23,1.86,2.21,2.49S66.45,55,64.78,55.9A12.69,12.69,0,0,1,61.32,57a17.21,17.21,0,0,1-3,.29Z" transform="translate(-0.75 -0.13)" style="fill:#3fb54f"/><path id="_Path_11" data-name="&lt;Path&gt;" d="M35.06,59a8.88,8.88,0,0,1-5.51-1.82,5,5,0,0,1,0-8.24,9.23,9.23,0,0,1,11,0,5,5,0,0,1,0,8.23A8.82,8.82,0,0,1,35.06,59" transform="translate(-0.75 -0.13)" style="fill:#3fb54f"/><path id="_Path_12" data-name="&lt;Path&gt;" d="M12.3,45.47c.22-.82.37-1.61.48-2.28l.15-.89c.06-.37.13-.76.2-1.16a3.32,3.32,0,0,1,.33-.79c.1-.19.2-.38.29-.6a1.36,1.36,0,0,0-.09-1.31v0l0,0a.92.92,0,0,0-.6-.19,2.07,2.07,0,0,0-1,.31.91.91,0,0,1-.26.06,1.83,1.83,0,0,0-.25.06,4.69,4.69,0,0,1-1.43.22A4.81,4.81,0,0,1,9,38.74a2.59,2.59,0,0,1,.86-.62,3.85,3.85,0,0,0,.4-.24c.33-.16.67-.33,1-.53a4.69,4.69,0,0,0,.88-.64,1,1,0,0,1,.3-.14.76.76,0,0,0,.43-.29l.31-.31a3.55,3.55,0,0,0,.84-1.06,11.44,11.44,0,0,0,1.25-3.47l.15-.62c.11-.44.24-.92.4-1.38.15.32.3.67.45,1.08.26.71.47,1.43.7,2.2s.54,1.81.89,2.72a.32.32,0,0,0,.33.23h.24c.07,0,.1,0,.13.09l.09.21.18-.14a2.1,2.1,0,0,1,1.39-.41l.51,0h.83l.31,0a.93.93,0,0,1,.65.22l-.72.39a11.84,11.84,0,0,1-2,.94H19.8a1.63,1.63,0,0,0-.58,1,1,1,0,0,0,.16.77,1.23,1.23,0,0,0,.52.56,1.4,1.4,0,0,1,.32.26,23.39,23.39,0,0,1,3.6,4.57h0c-.15,0-.32-.18-.49-.35l-.11-.12a14.8,14.8,0,0,0-2.37-1.53,14,14,0,0,1-2.64-1.77,1,1,0,0,0-.7-.3c-.62,0-1.13.64-1.68,1.31a7.15,7.15,0,0,1-.84.94,12.3,12.3,0,0,0-1.69,1.92l-.39.5c0,.08-.11.15-.17.23s-.27.35-.4.5Z" transform="translate(-0.75 -0.13)" style="fill:#fbdc2d"/>';//NO I18N
            var object = {"Name": I18N.getMsg("godaddy.title"), "url": baseurl + "godaddy", "title": "GoDaddy", "isSelected": godaddy, "image": true , "imagelocation":imagetag};//NO I18N
            arr.push(object);
        }
        jsonObj.menuLinks = arr;
        informationTabList.setProperties(jsonObj);
    }
        return informationTabList;
    },
    getLetsMgmtTabList: function(){
        var selectedTab = App.RequestCertController.selectedTab;
        var account = false;
        var deploy = false;
        var agents = false;
        var dnsp = false;
        if(selectedTab === "account"){account=true;}//NO I18N
        else if(selectedTab === "deploy"){deploy=true;}//NO I18N
        else if(selectedTab === "agents"){agents=true;}//NO I18N
        else if(selectedTab === "dnsprovider"){dnsp=true;}//NO I18N
        var baseurl = window.apiclientUrl+"LETSMgmt/";//NO I18N
        if(!kmpStandAlone)
        {
            baseurl = "#/SSLCertificatesView/LETSMgmt/";//NO I18N
        }
        var arr=new Array();
        var jsonObj =   {
    }
        if(window.userRole==="Administrator")
        {
            var object = {"Name":I18N.getMsg("js.letsencrypt.Account"),"url":baseurl+"LETSAccount","title":"Account","isSelected":account,"image":true};//NO I18N
            arr.push(object);
            var object = {"Name":I18N.getMsg("dns.global.provider"),"url":baseurl+"DNSProvider","title":"DNS Provider","isSelected":dnsp,"image":false};//NO I18N
            arr.push(object);
        }
        var object = {"Name":I18N.getMsg("js.sshkey.deploy"),"url":baseurl+"LETSDeploy","title":"Deploy","isSelected":deploy};//NO I18N
        arr.push(object);
        
            var object = {"Name":I18N.getMsg("js.letsencrypt.windowsAgent"),"url":baseurl+"WAgents","title":"Windows Agents","isSelected":agents};//NO I18N
            arr.push(object);
        
        jsonObj.menuLinks = arr;
            informationTabList.setProperties(jsonObj);
            return informationTabList;
    }
});

function goToPKICertReqState(req_id)//No I18N
{
	location.href = window.apiclientUrl+"SSLMgmt/Request/Edit/"+req_id; //No I18N
};

function goToPKICertCloseState(req_id)
{
    location.href = window.apiclientUrl+"SSLMgmt/Request/Closed/"+req_id; //No I18N
}

function showMailField(option)
{
    $('#CAMAIL').toggle();//No I18N
    if(option !=undefined && option =='cert')//No I18N
    {
        $('#CAMAILSEND').toggle();//No I18N
}
    else
    {
        $("#"+option).toggle();//No I18N
}
}

function chooseCertType(CertType)
{
    $("#CSRSelection").hide();
    $("#parentDomain").hide();
    $("#commonName").hide();
//    $("#New_Cert_Req").css("");//No I18N    
//    $("#Sub_Domain_Req").css("");//No I18N    
    if(CertType==="CSRSelection")
    {
        $("#CSRSelection").show();
        if(document.getElementById("isCSR").checked)
        {
            $("#CSRimport").show();
            $("#commonName").hide();        
        }
        else
        {
            $("#CSRimport").hide();
            $("#commonName").show();                    
            $("#commonName").find("label").text(I18N.getMsg("js.commonstr.certificatename"));//No I18N  
        }
        App.RequestCertController.requestType="New_Cert_Req";//No I18N    
    }
    else if(CertType==="parentDomain")
    {
        $("#parentDomain").show();
        $("#commonName").show();
        $("#commonName").find("label").text(I18N.getMsg("js.cert.sans"));//No I18N  
        App.RequestCertController.requestType="Sub_Domain_Req";//No I18N    
    }
}

function selectOsType(osType)
{
    var myGrid = $('#PKIInventoryList');
    var selRowIds;
    if(myGrid!=undefined)
    {
        selRowIds = myGrid.jqGrid('getGridParam','selarrrow'); //No I18N 
    }
    var serverType=document.getElementById("server_type").value;
    if(document.getElementById("server_type").value=='Windows')
    {
        $("#portDiv").hide();
        $("#path").attr("placeholder", "example C:\\mycert");
        if(selRowIds!=undefined && selRowIds.length > 0) {
            $("#dep_file_name").show();
    }
        if(App.RequestCertController.cert_type)
        {
            $("#cert_type").show();
        }
        $("#path_div").show();
    }
    else if(document.getElementById("server_type").value=='MSStore' || document.getElementById("server_type").value=='IIS')
    {
        $("#portDiv").hide();
        $("#dep_file_name").hide();
        $("#cert_type").hide();
        serverType="Windows";//No I18N 
    }
    else
    {
        $("#portDiv").show();
        $("#path").attr("placeholder", "example var/home/mycert");//NO I18N
        if(selRowIds!=undefined && selRowIds.length > 0) {
            $("#dep_file_name").show();
    }
        if(App.RequestCertController.cert_type)
        {
            $("#cert_type").show();
}
        $("#path_div").show();
    }
    getServerNameForDeployment(serverType);
}

function getDnsServersList()
{
    var dns_server = document.getElementById("dns_server").value;
    displayDnsserverForm(dns_server);
    getDnsServers(dns_server);
}

function displayDnsserverForm(dns_server)
{
    if(dns_server==="azure")
    {
        $("#cloudflare_dns_server").hide();
        $("#azure_dns_server").show();
    }
    else if(dns_server==="cloudflare")
    {
        $("#cloudflare_dns_server").show();
        $("#azure_dns_server").hide();
    }
}

function getDnsServers(dns_server)
{
    var ajaxUrl = '/api/pki/letsencrypt/getDnsServers?dns_server='+dns_server;//NO I18N
    var inputId;
    if(dns_server==="azure")
    {
        inputId="azure_subscription_id";//NO I18N
    }
    else if(dns_server ==="cloudflare")
    {
        inputId="cloudflare_email";//NO I18N
    }
    getAjaxApiRequest(ajaxUrl,"", function(jsonData) {
        var dnsList = jsonData.Servers;
        var encKeyLoc=[];
        if(dnsList.length>0)
        {
            var a;
            for (a = 0; a < jsonData.Servers.length; a++)
            {
                var temp = jsonData.Servers[a];
                encKeyLoc.push(temp);
            }
            $(function () {
            $("#"+inputId).autocomplete({
                   source: encKeyLoc, minLength: 0
               }).focus(function () {
                   $("#"+inputId).data("ui-autocomplete").search($("#"+inputId).val());
               }).data("ui-autocomplete")._renderItem = function (ul, encKeyLoc) {//NO I18N
                   var $el = $("<li>");//NO I18N
                   $el.append("<a href='javascript:getDnsServerDetails(\""+dns_server+"\",\""+ encKeyLoc.label+"\")'>" + encKeyLoc.value + "</a>");//NO I18N
                   if(!kmpStandAlone){
                       var len=$("#"+inputId).css("width");//NO I18N
                       $el.css( "width", len );//NO I18N
                   }
                   return $el.appendTo(ul);
               };
           });
        }
    });    
}

function getDnsServerDetails(dns_server,dns_id)
{
    var ajaxUrl = '/api/pki/letsencrypt/getDnsServerDetails?dns_server='+dns_server+'&dns_id='+dns_id;//NO I18N
    getAjaxApiRequest(ajaxUrl,"", function(jsonData) {
        var dnsDetails = jsonData.dns_server;
        fillDNSDetails(dnsDetails);
    });
}

function getServerNameForDeployment(serverType)
{
    var data="serverType="+serverType;//NO I18N
    var myGrid = $('#PKIInventoryList');
    if(myGrid!=undefined)
    {
    var selRowIds = myGrid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds!=undefined)
    {    
        if(selRowIds.length == 1) {
            $.each(selRowIds, function()
            {
                var id = this;
                var res_id = myGrid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                data+="&cert_id="+res_id;//NO I18N
            });
        }
        }
    }
        var ajaxRequestUrl = '/api/pki/request/getDeployServers'; //No I18N
    var encKeyLoc=[];
        getAjaxApiRequest(ajaxRequestUrl, data, function (jsonData) {
        var a;
        for (a = 0; a < jsonData.Servers.length; a++)
        {
            var temp = jsonData.Servers[a].trim();
            encKeyLoc.push(temp);
        }
        $(function () {
         $("#serverName").autocomplete({
                source: encKeyLoc, minLength: 0
            }).focus(function () {
                $("#serverName").data("ui-autocomplete").search($("#datacenter").val());
            }).data("ui-autocomplete")._renderItem = function (ul, encKeyLoc) {//NO I18N
                var $el = $("<li>");//NO I18N
                $el.append("<a href='javascript:getServerCredentialsForDeploment()'>" + encKeyLoc.value + "</a>");//NO I18N
                if(!kmpStandAlone){
                    var len=$("#serverName").css("width");//NO I18N
                    $el.css( "width", len );//NO I18N
                }
                return $el.appendTo(ul);
            };
        });
    });    
}

function getServerCredentialsForDeploment()
{
    var serverName=document.getElementById("serverName").value;
    var ajaxRequestUrl = '/api/pki/request/getDeployServersCredential?serverName='+serverName; //No I18N
    getAjaxApiRequest(ajaxRequestUrl, "", function (jsonData) {
        if(!jQuery.isEmptyObject(jsonData))
        {
            if(jsonData.userName!=undefined)
            {
        document.getElementById("userName").value=jsonData.userName;
        document.getElementById("pwd").placeholder=jsonData.password;
            }
            if(jsonData.isCertificate==1)
            {
                document.getElementById("cert").checked=true;
                $("#cert_file_div").show();
                if(jsonData.certFileName!=undefined)
                {
                    document.getElementById("cert_file").value=jsonData.certFileName;
                }
            }
            else
            {
                document.getElementById("cert").checked=false;
            }
            if(jsonData.isStore==1)
            {
                document.getElementById("store").checked=true;
                $("#store_file_div").show();
                if(jsonData.storeFileName!=undefined)
                {
                    document.getElementById("store_file").value=jsonData.storeFileName;
                }
            }
            else
            {
                document.getElementById("store").checked=false;
            }
            if(jsonData.path!=undefined)
            {
                document.getElementById("path").value=jsonData.path;
            }
            if(jsonData.port!=undefined)
            {
                document.getElementById("port").value=jsonData.port;
                $("#portDiv").show();
            }
            else
            {
                $("#portDiv").hide();
            }        
            document.getElementById("server_type").value=jsonData.serverType;
            selectOsType();
        }
    });
}

function selectDepType(osType)
{
    if(osType=='single')
    {
        var myGrid = $('#PKIInventoryList');
        var selRowIds;
        if(myGrid!=undefined)
        {        
            selRowIds = myGrid.jqGrid('getGridParam','selarrrow'); //No I18N         
        }
        if(selRowIds!=undefined && selRowIds.length == 1) {
            if(document.getElementById("server_type").value!='MSStore')
            {
        $("#dep_file_name").show();
        }
        }
        $("#multiple_deployment").hide();
        $("#single_deployment").show();
    }
    else
    {
        $("#multiple_deployment").show();
        $("#single_deployment").hide();
        $("#dep_file_name").hide();
    }
}

function selectCertType(certType)
{
    if(certType=='cert')
    {
        $("#cert_file_div").toggle();
    }
    else
    {
        $("#store_file_div").toggle();
    }
}

function isCSRChecked()
{
    if(document.getElementById("isCSR").checked)
    {
        $("#CSRimport").show();
        $("#commonName").hide();        
    }
    else
    {
        $("#CSRimport").hide();
        $("#commonName").show();
    }
}
function exportCert(ajaxRequestUrl)
{
    if (!window.location.origin) {
        window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
    }
    location.href=window.location.origin+ajaxRequestUrl;
}

function getCSRPassword(csr_id)
{
    var ajaxRequestUrl = '/api/pki/request/getCSRPassword'; //No I18N
    var data="csr_id="+csr_id;//No I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        $(".popover-content").html(jsonData.password)//No I18N
        $(".arrow").hide();//No I18N
        document.querySelector('.popover').style.maxWidth = "400px" ;//No I18N
        setTimeout(function () {
            $('.popover').popover('hide');//NO I18N
        }, 5000);
    }); 
}

function getLetsEncryptPassword(req_id)
{
    var ajaxRequestUrl = '/api/pki/letsencrypt/getPassword';//NO I18N
    var data= "req_id="+req_id;//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        $(".popover-content").html(jsonData.password)//No I18N
        $(".arrow").hide();
        document.querySelector('.popover').style.maxWidth = "400px" ;//No I18N
        setTimeout(function () {
            $('.popover').popover('hide');
        }, 5000);
    }); 
}

function getGoDaddyPassword(req_id)
{
    var ajaxRequestUrl = '/api/pki/godaddy/getPassword';//NO I18N
    var data= "req_id="+req_id;//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        $(".popover-content").html(jsonData.password)//No I18N
        $(".arrow").hide();
        document.querySelector('.popover').style.maxWidth = "400px" ;//No I18N
        setTimeout(function () {
            $('.popover').popover('hide');
        }, 5000);
    }); 
}

function showChallengesPage(req_id)
{
    App.RequestCertController.req_id=req_id;
    redirectUrl("SSLMgmt/LetsEncryptChallenges/"+req_id); //No I18N
}

function authorizeRequest(req_id)
{
    var ajaxRequestUrl = '/api/pki/letsencrypt/authorizeRequest';//NO I18N
    var data= "req_id="+req_id;//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
        if(jsonData.Status==="Success")
        {
            messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
            {{App.Request.letsEncryptRequestsList();}}
        }
        else{
            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
        }
            
    });
}


function exportLetsHistoryCertificate(file)
{
    var grid = jQuery("#historyList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
        showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
        return;
    }
    var ver_id = grid.jqGrid('getCell',selRowIds,'VERSION_ID');//NO I18N
    var cName = grid.jqGrid('getCell',selRowIds,'DOMAIN');//NO I18N    
    var ajaxRequestUrl = '/api/pki/letsencrypt/exportHistoryCert?ver_id='+ver_id+'&cName='+cName+"&file="+file; //No I18N
    if (!window.location.origin) {
        window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
    }
    location.href=window.location.origin+ajaxRequestUrl;
}

function exportGoDaddyHistoryCertificate(file)
{
    var grid = jQuery("#historyList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
        showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
        return;
    }
    var ver_id = grid.jqGrid('getCell',selRowIds,'VERSION_ID');//NO I18N
    var cName = grid.jqGrid('getCell',selRowIds,'CommonName');//NO I18N    
    var ajaxRequestUrl = '/api/pki/godaddy/exportHistoryCert?ver_id='+ver_id+'&cName='+cName+"&file="+file; //No I18N
    if (!window.location.origin) {
        window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
    }
    location.href=window.location.origin+ajaxRequestUrl;
}

function getNewChallenge(domain,cid)
{
    var ajaxRequestUrl = '/api/pki/letsencrypt/getNewChallenge';//NO I18N
    domain=domain+","+cid;//NO I18N
    var params = 'domain='+domain+'&req_id='+App.RequestCertController.req_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
       if(jsonData.Status === "Success")
       {
           App.Request.letsEncryptRequestsChallenges(App.RequestCertController.req_id);
       }
       else
       {
            messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
       }
    });
}

function downloadAgentKMP(agent)
{
    var ajaxRequestUrl = '/api/pki/letsencrypt/downloadAgent?agentType='+agent;//NO I18N
    if (!window.location.origin) {
        window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
    }
    location.href=window.location.origin+ajaxRequestUrl;    
}

function showDeployCertDetails()
{
    if(document.getElementById("deploy_certificate").checked)
    {
        $("#http_challenge").show();
    }
    else
    {
        $("#http_challenge").hide();
    }
}

function chooseChallengeType(challenge)
{
    if(challenge==="dns-01")
    {
        $("#dns_challenge").show();
        $("#deploycertcheck").show();
        $("#http_challenge").show();
        $("#path_div").hide();
    }
    else
    {
        $("#deploycertcheck").hide();
        $("#http_challenge").show();
        $("#dns_challenge").hide();
        $("#path_div").show();
    }
}

function chooseAgentType(agent)
{
    if(agent==="linux")
    {
        $("#windowsAgent").hide();
        $("#linuxAgent").show();
    }
    else
    {
        $("#windowsAgent").show();
        $("#linuxAgent").hide();
    }
}

function fillDNSDetails(dnsDetails)
{
    var dns_server = dnsDetails.dns_server;
    if(dns_server==="azure")
    {
        fillAzureDNS(dnsDetails);
    }
    else if(dns_server==="cloudflare")
    {
        fillCloudFlareDNS(dnsDetails);
}
}

function fillCloudFlareDNS(dnsDetails)
{
    document.getElementById("cloudflare_email").value=dnsDetails.email
    document.getElementById("cloudflare_auth_key").placeholder=dnsDetails.auth_key
}

function fillAzureDNS(dnsDetails)
{
    document.getElementById("azure_subscription_id").value=dnsDetails.sub_id;
    document.getElementById("azure_tenant_id").value=dnsDetails.tenant_id;
    document.getElementById("azure_client_id").value=dnsDetails.client_id;
    document.getElementById("azure_resource_group").value=dnsDetails.resource_group_name;
    document.getElementById("azure_secret").placeholder=dnsDetails.secret;
}

function addNewAccount()
{
    var ids = jQuery("#PKILetsEncrypt").jqGrid('getDataIDs');//NO I18N
    if(ids.length>0)
    {
        showAlert(I18N.getMsg("js.letsencrypt.accountavailable"));//No I18N
        return;
    }
    redirectUrl("LETSMgmt/addNewAccount/");//NO I18N
}

function newRegistration()
{
    var ids = jQuery("#PKILetsEncrypt").jqGrid('getDataIDs');//NO I18N
    if(ids.length>0)
    {
        showAlert(I18N.getMsg("js.letsencrypt.accountavailable"));//No I18N
        return;
    }
    redirectUrl("LETSMgmt/newRegistration/");//NO I18N
}

function deleteAccount()
{
    var grid = jQuery("#PKILetsEncrypt"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    var account_ids="";
    if(selRowIds == undefined || selRowIds.length == 0) {
        showAlert(I18N.getMsg('js.letsencrypt.selectoneaccount')); //No I18N
        return;
    }
    vConfirmation(I18N.getMsg('js.letsencrypt.deleteconfirm'),function(){//NO I18N
    $.each(selRowIds, function()
    {
        var id = this;
        var account_id = grid.jqGrid('getCell', id, 'ACCOUNT_ID'); //No I18N
        if(account_ids!=="")
        {
            account_ids=account_ids+","+account_id;
        }
        else
        {
            account_ids=account_id;
        }
    });
    var data = {

    };
    data.account_ids = account_ids;
    var ajaxRequestUrl = '/api/pki/letsencrypt/deleteAccounts'; //No I18N
    data.pmpcp=Get_Cookie('pmpcc');//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
            if(jsonData.Status==="Success")
            {
                App.Request.listLetsEncryptAccounts();
                messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N
            }
            else
            {
                messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N
            }
        });
    });
}

function addDomainMapping()
{
    App.RequestCertController.sdomain="";
    App.RequestCertController.agentid="";
    App.RequestCertController.edit=false;
    App.RequestCertController.mapping_id="";    
    App.RequestCertController.challengeType="";
    App.RequestCertController.dns_server="";
    document.getElementById("addDomainMappingHidden").click();
}

function redirectDomainMapping()
{
    var domain = App.RequestCertController.domain;
    App.RequestCertController.sdomain=domain;
    App.RequestCertController.agentid="";
    App.RequestCertController.edit=false;
    App.RequestCertController.mapping_id="";
    document.getElementById("closeButton").click();
    redirectUrl("LETSMgmt/LETSDeployFilter/"+domain);//NO I18N
}

function showDomainDeployStatus(domainName,challengeId,challengeType)
{
    var req_id = App.RequestCertController.req_id;
    var ajaxRequestUrl = "/api/pki/letsencrypt/domainDeployStatus";//NO I18N
    var params='domain='+domainName+'&challengeId='+challengeId+'&req_id='+req_id;//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
        var list=jsonData.deployList;
        if(list.length>0)
        {
            document.getElementById("deployStatus").click();
            App.Request.deployStatus(jsonData,challengeType);
        }
        else
        {
            showAlert(I18N.getMsg("deploy.status.no"));//NO I18N
        }
    });
}

function deployChallengeFile(challengeId,agentId,osType,domain,challengeType,dns_server)
{
    var req_id = App.RequestCertController.req_id;
    var ajaxRequestUrl = "/api/pki/letsencrypt/deployChallengeFile";//NO I18N
    var params = 'req_id='+req_id+'&challengeId='+challengeId+'&agentId='+agentId+'&osType='+osType+"&challengeType="+challengeType+"&dns_server="+dns_server;//NO I18N
    ajaxapicall(ajaxRequestUrl,params,true,"");    
}

function deployCertificate(req_id,domains)
{
    var ajaxRequestUrl = "/api/pki/letsencrypt/deployCertificate";//NO I18N
    var params="domains="+domains+"&req_id="+req_id;//NO I18N
    ajaxapicall(ajaxRequestUrl,params,false,"");
    messageNotification("messageNotifySuccess",I18N.getMsg("deployment.started"));//NO I18N
}

function openAgreementWindow(element)
{
    if(element.checked)
    {
        window.open("https://acme-v01.api.letsencrypt.org/terms", '_blank');
    }
}

function checkPushOptions(cn,kn,sn)
{
    if(cn!=="no")
    {
        document.getElementById("certificate").checked=true;
    }
    if(kn!=='no')
    {
        document.getElementById("privateKey").checked=true;
    }
    if(sn!=='no')
    {
        document.getElementById('keyStore').checked=true;
    }
    selectPushOption();
}

function selectPushOption()
{
    if(document.getElementById("certificate").checked)
    {
        $("#certfilediv").show();
    }
    else
    {
        $("#certfilediv").hide();
    }
    
    if(document.getElementById("privateKey").checked)
    {
        $("#privatekeydiv").show();
    }
    else
    {
        $("#privatekeydiv").hide();
    }
    
    if(document.getElementById("keyStore").checked)
    {
        $("#keystorediv").show();
    }
    else
    {   
        $("#keystorediv").hide();
    }
    
    if(document.getElementById("certificate").checked || document.getElementById("privateKey").checked || document.getElementById("keyStore").checked)
    {
        $("#keypathdiv").show();
    }
    else
    {
        $("#keypathdiv").hide();
    }
}

function chooseRenewalKeyGoDaddy(key)
{
    if(key==="uploadkey")
    {
        $("#fileDiv").show();
        $("#keydiv").hide();
    }
    else
    {
        $("#fileDiv").hide();
        $("#keydiv").show();
    }
}

function chooseRenewalKeyGoDaddy1(key)
{
    if(key==="uploadkey")
    {
        $("#fileDiv").show();
        $("#keydiv").hide();
    }
    else if(key=="samekey")
    {
        $("#fileDiv").hide();
        $("#keydiv").hide();
    }
    else
    {
        $("#fileDiv").hide();
        $("#keydiv").show();
    }
}

function chooseRenewalKey(key)
{
    if(key==="uploadkey")
    {
        $("#fileDiv").show();
        $("#keydiv").hide();
    }
    else
    {
        $("#fileDiv").hide();
        $("#keydiv").show();
    }
    
    if(key==="samekey")
    {
        $('#ALG_TYPE').find('option').remove();
        $("#ALG_TYPE").append(new Option("RSA", "RSA"));
        $('#ALG_TYPE').prop('disabled', true);
    }
    else
    {
        $('#ALG_TYPE').find('option').remove();
        $("#ALG_TYPE").append(new Option("RSA", "RSA"));
        $("#ALG_TYPE").append(new Option("EC", "EC"));
        $('#ALG_TYPE').prop('disabled', false);
    }
}

function sanNameAutoFill()
{
    var value=$("#common_name").val();
    $("#alt_names").val(value);
}

function changeSigningType()
{
    var selValue=$("#sign_type").val();
    if(selValue==="root")
    {
        $("#msca_div").hide();
        $("#rootsign_div").show();
        getRootCertificates();
    }
    else
    {
        $("#rootsign_div").hide();
        $("#msca_div").show();
    }
}

function changeRootSignType()
{
    var selValue=$("#sign_type").val();
    if(selValue==="user")
    {
        $("#aduser_div").hide();
        $("#user_div").show();
        $('#cert_details').show();
        $('#sign').show();
        $('#next').hide();
        getRootCertificates();
    }
    else
    {
        $("#user_div").hide();
        $("#aduser_div").show();
        $('#cert_details').hide();
        document.getElementById("isCertDetais").checked=true;
        $('#certDetails_div').hide();
        $('#sign').hide();
        $('#next').show();
        App.Settings.getDomains();
    }    
}

function getRootCertificates()
{
    var ajaxRequestUrl = '/api/pki/request/getRootCertificate'; //No I18N
    $("#root_cert").empty();
    ajaxRequestWithCookie(ajaxRequestUrl,"",false,"",true,function(jsonData){
            var obj=jsonData;
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    $("#root_cert").append("<option value='"+key+"' >"+obj[key]+"</option>");//No I18N
            }               
        }
    });            
}

function showGlobalDNSDetails(id)
{
    document.getElementById("adddns").click();
    if(id!==undefined)
    {
        App.RequestCertController.dns_id=id;
        var ajaxUrl = '/api/pki/letsencrypt/getGlobalDNSID?id='+id;//NO I18N
        getAjaxApiRequest(ajaxUrl,"", function(jsonData) {
            $("#dns_server").val(jsonData.dns_server.dns_server);
            $("#dns_server").hide();$("#dns_server_label").show();//NO I18N
            if(jsonData.dns_server.dns_server==="azure")
            {
                $("#dns_server_label").text(I18N.getMsg("letsencrypt.dnsserver.azure"));//NO I18N
            }
            else
            {
                $("#dns_server_label").text(I18N.getMsg("letsencrypt.dnsserver.cloudflare"));//NO I18N
            }
            getDnsServersList();
            fillDNSDetails(jsonData.dns_server);
        });
    }    
}

function selectdefaultdns()
{
    if($("#Challenge_Type").val()=="dns-01")
    {
        $("#dns_default_server").find('option').remove();
        var ajaxUrl = '/api/pki/letsencrypt/getDefaultDNSlist';//NO I18N
        getAjaxApiRequest(ajaxUrl,"", function(jsonData) {
            var list = jsonData.list;
            if(list.length>0)
            {
                $("#defaultdnsdiv").show();                
                var i;
                $("#dns_default_server").append(new Option("-----Optional-----","-1"));//NO I18N
                for(i=0;i<list.length;i++)
                {
                   var data = list[i];                                 
                   var option;
                   for (var j in data)
                   {
                        if(j==="azure")
                        {
                            option = '<option value="'+data[j]+'">Azure</option>';//NO I18N

                        }
                        else if(j==="cloudflare")
                        {
                            option = '<option value="'+data[j]+'">Cloudflare</option>';//NO I18N
                        }
                   }

                   
                   $("#dns_default_server").append(option);
                }
            }
            else
            {
                $("#defaultdnsdiv").show();
                $("#dns_default_server").find('option').remove();
                $("#dns_default_server").append(new Option("-----Optional-----","-1"));//NO I18N                
            }
        });
    }
    else
    {
        $("#defaultdnsdiv").hide();
        $("#dns_default_server").find('option').remove();
        $("#dns_default_server").append(new Option("-----Optional-----","-1"));//NO I18N
    }
}

function assignDefaultDNS()
{
    var grid = jQuery("#PendingCertList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0) {
        showAlert(I18N.getMsg('js.letsencrypt.selectatleastone')); //No I18N
        return;
    }
    var req_ids="";
    var stop=false;
    $.each(selRowIds, function()
    {
        var id = this;        
        var req_id = grid.jqGrid('getCell', id, 'REQUEST_ID'); //No I18N
        var challengeType = grid.jqGrid('getCell', id, 'CHALLENGETYPE'); //No I18N
        var commonname = grid.jqGrid('getCell',id,'DOMAINS');//NO I18N
        if(challengeType==="http-01")
        {
            showAlert(I18N.getMsg("assign.defaultdns.httpchallenge",new Array(commonname)));//NO I18N
            stop=true;
            return;            
        }
        if(req_ids!=="")
        {
            req_ids=req_ids+","+req_id;//NO I18N
        }
        else
        {
            req_ids=req_id;
        }
    });
    if(stop)
    {
        return;
    }
    var ajaxRequestUrl = '/api/pki/letsencrypt/getRequestDefaultDNS'; //No I18N
    var params="req_id="+req_ids+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
    getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
        var list = jsonData.list;
        if(list.length===0)
        {
            showAlert(I18N.getMsg("assign.defaultdns.nodnsconfigured"));//NO I18N
            return;
        }
        else
        {
            document.getElementById("assigndefaultdns").click();
            var i;
            $("#dns_default_server").find('option').remove();
            $("#dns_default_server").append(new Option("-----Optional-----","-1"));//NO I18N
            for(i=0;i<list.length;i++)
            {
               var data = list[i];                                 
               var option;
               for (var j in data)
               {
                    if(j==="azure")
                    {
                        option = '<option value="'+data[j]+'">Azure</option>';//NO I18N

                    }
                    else if(j==="cloudflare")
                    {
                        option = '<option value="'+data[j]+'">Cloudflare</option>';//NO I18N
                    }
               }


               $("#dns_default_server").append(option);
            }
            if(jsonData.selectDNS!==undefined)
            {
                $("#dns_default_server").val(jsonData.selectDNS);
            }
        }                                                     
    });
}


function certType()
{
    var ucc=false;
    var dv=false;
    var ov=false;
    var ev=false;
    var type = document.getElementById("Cert_Type").value;
    var cert_type = type.split("_");    
    if(cert_type[0]==="DV")
    {
        dv=true;
    }
    else if(cert_type[0]==="OV")
    {
        ov=true;
    }
    else if(cert_type[0]==="EV")
    {
        ev=true;
    }
    else if(cert_type[0]==="UCC")
    {
        ucc=true;
        if(cert_type[1]==="DV")
        {
            dv=true;
        }
        else if(cert_type[1]==="OV")
        {
            ov=true;
        }
        else if(cert_type[1]==="EV")
        {
            ev=true;
        }
    }
    
    if(ucc)
    {
        $("#sandiv").show();
    }
    else
    {
        $("#sandiv").hide();
    }
    
    if(ov)
    {
        $("#intelvprodiv").show();
    }
    else
    {
        $("#intelvprodiv").hide();
    }
    
    if(ev)
    {
        $("#jobtitlediv").show();
        $("#regagentdiv").show();
        $("#regnumberdiv").show();
        $("#assumednamediv").show();
    }
    else
    {
        $("#jobtitlediv").hide();
        $("#regagentdiv").hide();
        $("#regnumberdiv").hide();
        $("#assumednamediv").hide();
    }    
    
    if(ov||ev)
    {
        $("#orgdetailsdiv").show();
    }
    else
    {
        $("#orgdetailsdiv").hide();
    }
}

function revokeGoDaddy()
{
    var grid = jQuery("#PendingCertList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
        showAlert(I18N.getMsg('godaddy.select.anorder')); //No I18N
        return;
    }
    document.getElementById("revokebutton").click();
}

function renewGoDaddy()
{
    var grid = jQuery("#PendingCertList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
        showAlert(I18N.getMsg('godaddy.select.anorder')); //No I18N
        return;
    }  
    var order_status = grid.jqGrid('getCell', selRowIds, 'Order_Status'); //No I18N     
//    if(order_status!=="CERTIFICATE_ISSUED")
//    {
//        showAlert(I18N.getMsg("godaddy.notissued.alert"));//NO I18N
//        return;
//    }
    document.getElementById("renewbutton").click();
}

function reissueGoDaddy()
{
    var grid = jQuery("#PendingCertList"); //No I18N
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
    if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
        showAlert(I18N.getMsg('godaddy.select.anorder')); //No I18N
        return;
    }    
    var order_status = grid.jqGrid('getCell', selRowIds, 'Order_Status'); //No I18N     
//    if(order_status!=="CERTIFICATE_ISSUED")
//    {
//        showAlert(I18N.getMsg("godaddy.notissued.alert"));//NO I18N
//        return;
//    }
    document.getElementById("reissuebutton").click();
}

function goToGoDaddyOrderDetails(id)
    {
    App.RequestCertController.order_id=id;    
    redirectUrl("SSLMgmt/godaddyOrderDetails/"+id);//No I18N
    }

function alertAddAccount()
{
    vConfirmation(I18N.getMsg('godaddy.add.account'),function(){//NO I18N
        if(App.ApplicationController.isAdmin===true)
        {
            document.getElementById("godaddyaccount").click();
        }
    });    
}

function authorizeGoDaddyRequest(id)
{
    
}

function checkGoDaddyCertificate(id)
{
    var ajaxUrl = '/api/pki/godaddy/getCertificate?order_id='+id; //No I18N  
    getAjaxApiRequest(ajaxUrl,"",function(jsonData){
        if(jsonData.Status === "Success")
        {            
             messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
             {{App.Request.godaddyRequestsList();}}
        }
        else
        {
             messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
        }
    });
}

function isNumber(evt)
{
    evt = (evt) ? evt : window.event;
    var charCode = (evt.which) ? evt.which : evt.keyCode;
    if (charCode > 31 && (charCode < 48 || charCode > 57)) {
        return false;
    }
    return true;
}