// $Id$
/* Settings Routes */
App.DiscoveryRoute = Ember.Route.extend({
     model: function(params) {
         return getMenusForSideView("Discovery");//No I18N
     },
	setupController: function(controller) {
            if(!kmpStandAlone){
            App.SettingsCommonController.selectedTab = "ssl"; //No I18N
        }
            controller.set('content', App.Discovery.getDiscoveryTabList());  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into: 'application', outlet: 'details'}); //No I18N
            }
            else{
                localStorage.setItem("currentView","Discovery/SSL");	//NO I18N
                selectKMPTab("ssl_discovery");//NO I18N
                this.render('Discovery',{ outlet: 'keyInfo'});//No I18N
            }   
        }  
});


App.DiscoverySSLRoute = App.DiscoveryRoute.extend({
	setupController: function(controller) {
            controller.set('content', App.Discovery.getDiscoveryTabList("ssl"));  //No I18N 
	},
        model: function(params) {
            App.SettingsCommonController.selectedTab = "ssl"; //No I18N
            showHidepmpHelp("ssldiscoveryhelp");//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into:"Discovery", outlet: 'discovery'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Discovery/SSL");	//NO I18N
                this.render('DiscoveryAll',{ into:"Discovery",outlet: 'discInfo'});//No I18N
            }   
        }
});

App.DiscoverySMTPRoute = App.DiscoveryRoute.extend({
	setupController: function(controller) {
            controller.set('content', App.Discovery.getDiscoveryTabList("smtp"));  //No I18N 
	},
        model: function(params) {
            App.SettingsCommonController.selectedTab = "smtp"; //No I18N            
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into:"Discovery", outlet: 'discovery'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Discovery/SMTP");	//NO I18N
                this.render('DiscoveryAll',{ into:"Discovery",outlet: 'discInfo'});//No I18N
            }   
        }
});

App.DiscoveryMSLocalCARoute = App.DiscoveryRoute.extend({
	setupController: function(controller) {
            controller.set('content', App.Discovery.getDiscoveryTabList("ms"));  //No I18N 
	},
        model: function(params) {
            App.SettingsCommonController.selectedTab = "ms"; //No I18N
	},
	renderTemplate: function() {this.render({into: 'Discovery', outlet: 'discovery'});} //No I18N
});

App.DiscoveryCertStoreRoute = App.DiscoveryRoute.extend({
	setupController: function(controller) {
            controller.set('content', App.Discovery.getDiscoveryTabList("cs"));  //No I18N 
	},
        model: function(params) {
            App.SettingsCommonController.selectedTab = "cs"; //No I18N
            showHidepmpHelp("certStorehelp");//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render("CertStore",{into:"Discovery", outlet: 'discovery'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Discovery/certStore");	//NO I18N
                this.render("CertStore",{ into:"Discovery",outlet: 'discInfo'});//No I18N
            }   
        }
});

App.DiscoverySSHRoute = App.DiscoveryRoute.extend({
	setupController: function(controller) {
            controller.set('content', App.Discovery.getDiscoveryTabList("ssh"));  //No I18N 
	},
        model: function(params) {
            App.SettingsCommonController.selectedTab = "ssh"; //No I18N
	},
	renderTemplate: function() {this.render({into: 'Discovery', outlet: 'discovery'});} //No I18N
});

App.DiscoveryADRoute = App.DiscoveryRoute.extend({
	setupController: function(controller) {
            controller.set('content', App.Discovery.getDiscoveryTabList("ad"));  //No I18N 
	},
        model: function(params) {
            App.SettingsCommonController.selectedTab = "ad"; //No I18N
            showHidepmpHelp("ad_discoveryhelp");//No I18N
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render({into:"Discovery", outlet: 'discovery'});//No I18N
            }
            else{
                localStorage.setItem("currentView","Discovery/AD");	//NO I18N
                this.render('DiscoveryAll',{ into:"Discovery",outlet: 'discInfo'});//No I18N
            }   
        }

});

App.DiscoveryADUserCertRoute = App.DiscoveryRoute.extend({
   setupController: function(controller) {
            controller.set('content', App.Discovery.getDiscoveryTabList("ad"));  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('ADUserCertificate',{into:"Discovery", outlet: 'discovery'});//No I18N
            }
            else{
                $("#pageTitleIcon").hide();
                localStorage.setItem("currentView","Discovery/ADUserCert");	//NO I18N
                this.render('ADUserCertificate',{ into:"Discovery",outlet: 'discInfo'});//No I18N
            }   
        }
});

function showHidepmpHelp(div)
{
    $("#pageTitleIcon").show();
    $("#ssldiscoveryhelp").hide();
    $("#certStorehelp").hide();
    $("#ad_discoveryhelp").hide();
    $("#"+div).show();
}

App.DiscoveryAuditDiscoveryRoute = Ember.Route.extend({
    	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('AuditDiscovery',{into:"Discovery", outlet: 'discovery'});//No I18N
            }
            else{
                $("#pageTitleIcon").hide();
                localStorage.setItem("currentView","Discovery/AuditDiscovery");	//NO I18N
                this.render('AuditDiscovery',{ into:"Discovery",outlet: 'discInfo'});//No I18N
            }   
        }
});

App.DiscoveryDetailedAuditDiscoveryRoute = Ember.Route.extend({
    model: function(params) {
		App.DiscoveryDataController.discoveryAudit_id = params.discoveryAudit_id; //No I18N
        },
        setupController: function(controller,model) {
	},
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('DetailedAuditDiscovery',{into:"Discovery", outlet: 'discovery'});//No I18N
            }
            else{
                $("#pageTitleIcon").hide();
                localStorage.setItem("currentView","Discovery/AuditDiscovery");	//NO I18N
                this.render('DetailedAuditDiscovery',{ into:"Discovery",outlet: 'discInfo'});//No I18N
            }   
        }

});

function discoveryType(type)
{
    if(type=='ssh')
    {
        $("#domainDiscovery").show()
        document.getElementById("port").value="22";//No I18N
        $("#ssl_port_label").hide();
        $("#ssh_help_label").show();
        $("#ssl_help_label").hide();
        $("#adDetailsForm").hide();
        $("#sslDisType").hide();
        $("#sshLandingServer").show();
        disocoveryLSSelection("landingserver");
    }
    else if(type=="ssl")
    {
        document.getElementById("port").value="443";//No I18N
        $("#ssl_port_label").show();
        $("#adDetailsForm").hide();
        $("#sslDisType").show();
        $("#DomainType").val(0);
        $("#ssl_help_label").show();
        $("#ssh_help_label").hide();
        $("#sshLandingServer").hide();
    }
    else if(type=="ad")
    {
        $("#domainDiscovery").hide()
        $("#adDetailsForm").show();
        $("#sshLandingServer").hide();
        if (!kmpStandAlone)
        {
            $("#userimp_id").hide();
}
}
    else if(type=="smtp")
    {
        document.getElementById("port").value="465";//No I18N   
        $("#discovery_type").hide();
        $("#ssl_port_label").show();        
        $("#discovery_help").hide();
}
}
