// $Id$
App.DiscoveryView = Ember.View.extend({
	templateName: 'Discovery',//No I18N
		didInsertElement: function(){
            if(!kmpStandAlone){
                showHidepmpHelp("ssldiscoveryhelp");//No I18N
                selectKMPTab("ssl_discovery");//NO I18N
			}
        }
		});

App.DiscoverySSHView = Ember.View.extend({
	templateName: 'DiscoveryAll',//No I18N
		didInsertElement: function(){
                        discoveryType('ssh');//No I18N
                }
});

App.DiscoverySSLView = Ember.View.extend({
	templateName: 'DiscoveryAll',//No I18N
		didInsertElement: function(){
                        discoveryType('ssl');//No I18N
            if(!kmpStandAlone){
                selectKMPTab("ssl_discovery");//NO I18N
                }
        }
});

App.DiscoverySMTPView = Ember.View.extend({
	templateName: 'DiscoveryAll',//No I18N
		didInsertElement: function(){
                        discoveryType('smtp');//No I18N            
        }
});

App.DiscoveryMSLocalCAView = Ember.View.extend({
	templateName: 'MSLocalCA',//No I18N
        didInsertElement: function(){
            if(!kmpStandAlone){
                selectKMPTab("ssl_discovery");//NO I18N
            }                        
        }
});

App.CertStoreView = Ember.View.extend({
	templateName: 'CertStore',//No I18N
        didInsertElement: function(){
            if(!kmpStandAlone){
                selectKMPTab("ssl_discovery");//NO I18N
            }                        
       
            $("#FROM_DATE").datepicker().datepicker("setDate", new Date());
            $("#TO_DATE").datepicker().datepicker("setDate", new Date());
            $("#CACertTypeID3").on('change', function() {
                $("#time_filter").toggle();
            });
            App.DiscoveryDataController.isPasswordNeeded=true;
            $("#CACertTypeID4").on('change', function() {
                $("#template_filter").toggle();
            });
            getMSCertStoreServer(false);
        }
});

App.DiscoveryADView = Ember.View.extend({
	templateName: 'DiscoveryAll',//No I18N
		didInsertElement: function(){
                    discoveryType('ad');//No I18N
                    $("#adUserlink").show();
                    $("#adUserlink").css("display","inline-block");
                    $(".hlpan_wrap").hide();
                    App.Settings.getDomains();
            if(!kmpStandAlone){
                selectKMPTab("ssl_discovery");//NO I18N
                }
        }
});

App.ADUserCertificateView = Ember.View.extend({
	templateName: 'ADUserCertificate',//No I18N
		didInsertElement: function(){
                    getADUserCertificate();
            if(!kmpStandAlone){
                selectKMPTab("ssl_discovery");//NO I18N
                }
        }
});

App.AuditDiscoveryView = Ember.View.extend({
	templateName: 'AuditDiscovery',//No I18N
		didInsertElement: function(){
                    App.Discovery.viewDiscoveryAudit();
            if(!kmpStandAlone){
                selectKMPTab("ssl_discovery");//NO I18N
		}
        }
});

App.DetailedAuditDiscoveryView = Ember.View.extend({
	templateName: 'DetailedAuditDiscovery',//No I18N
		didInsertElement: function(){
                    App.Discovery.displayIndividualDiscoveryAudit(App.DiscoveryDataController.discoveryAudit_id);  
            if(!kmpStandAlone){
                selectKMPTab("ssl_discovery");//NO I18N
		}
        }
});

function displayIpRangeFields(discoverType)
{
	$("#useIPHostNameDiv").css('display','none');  //No I18N
	$("#useIpRangeDiv").css('display','none'); //No I18N
	$("#useCsvImportDiv").css('display','none'); //No I18N 

	if(discoverType.id === "useIPHostName") //No I18N
	{
		$("#useIPHostNameDiv").css('display','block'); //No I18N
	}
	else if(discoverType.id === "useIPRange") //No I18N
	{
		$("#useIpRangeDiv").css('display','block'); //No I18N 
	}
	if(discoverType.id === "useCSV") //No I18N
	{
		$("#useCsvImportDiv").css('display','block'); //No I18N
	}
}

function checkForLocalhostinFile()
{
    var f = document.getElementById("importCsv").files[0];
    if (f) {
    var r = new FileReader();
    var check=true;
    var loopBack=false;
    r.onload = function(e) { 
        var discoverDomains = e.target.result;
        var lines=discoverDomains.split("\n");//No I18N
        var temp="";
        for (var i=0; i < lines.length; i++)
        {
            var line=lines[i].trim();
            temp=temp+line;
            if(i!==lines.length-1)
            {
                temp=temp+"\n";//No I18N
            }
            var words=line.split(" ");
            if(words.length>2)
            {
                check=false;
                break;
            }
            if(words.length===2)
            {
                if(window.cur_path=="Discovery.SSH")
                {
                    var isnum = (/^[0-9]+$/).test(words[1].trim());//Check the PORT value is digits
                    if(!isnum){check=false;break;}                   
                }else{
                    var prtlist=words[1].split(",");
                    for(var j=0;j<prtlist.length;j++)
                    {
                        var port=prtlist[j];
                        var isnum = (/^[0-9]+$/).test(port.trim());//Check the PORT value is digits
                        if(!isnum){check=false;break;}
                    }
                    }
            }
            if(words[0].indexOf('127')===0 || words[0].toLowerCase()==="localhost")
            {
                loopBack = true;
            }
        }
        
        if(document.getElementById("LSServer").value!=="-1" && loopBack)
        {
                showAlert(I18N.getMsg("loopback.address.contains"));//NO I18N
                var browse=$('#importCsv');
                var textfile=document.getElementById('textfile');
                clearfileElt(browse,textfile);
                return;
        }
        if(check){
            window.FILE_CONTENT=temp;
            $('#discoverDomains').val(discoverDomains);//No I18N
        }
        else
        {
            showAlert(I18N.getMsg('js.file.selectaFileWithProperFormat')); //NO I18N
            var browse=$('#importCsv');
            var textfile=document.getElementById('textfile');
            clearfileElt(browse,textfile);
        }
    }
    r.readAsText(f);
    } 
    else { 
        showAlert(I18N.getMsg('js.file.failedToLoadFile'));//NO I18N
    }
}

//Validate file content
function loadFileText(evt) {
    var f = evt.target.files[0];
    if (f) {
    var r = new FileReader();
    var check=true;
    var loopBack=false;
    r.onload = function(e) { 
        var discoverDomains = e.target.result;
        var lines=discoverDomains.split("\n");//No I18N
        var temp="";
        for (var i=0; i < lines.length; i++)
        {
            var line=lines[i].trim();
            var words=line.split(" ");
            if(words.length>2)
            {
                continue;
            }
            if(words.length===2)
            {
                if(window.cur_path=="Discovery.SSH")
                {
                    var isnum = (/^[0-9]+$/).test(words[1].trim());//Check the PORT value is digits
                    if(!isnum){continue;}
                }else{
                    var prtlist=words[1].split(",");
                    for(var j=0;j<prtlist.length;j++)
                    {
                        var port=prtlist[j];
                var isnum = (/^[0-9]+$/).test(port.trim());//Check the PORT value is digits
                        if(!isnum){continue;}
            }
        }
            }
            temp=temp+line;
            if(i!==lines.length-1)
            {
                temp=temp+"\n";//No I18N
            }
            if(words[0].indexOf('127')===0 || words[0].toLowerCase()==="localhost")
            {
                loopBack = true;
        }
        }
        
        if(document.getElementById("LSServer").value!=="-1" && loopBack)
        {
                showAlert(I18N.getMsg("loopback.address.contains"));//NO I18N
                var browse=$('#importCsv');
                var textfile=document.getElementById('textfile');
                clearfileElt(browse,textfile);
                return;
        }
        if(check){
            window.FILE_CONTENT=temp;
            $('#discoverDomains').val(discoverDomains);//No I18N
        }
        else
        {
            showAlert(I18N.getMsg('js.file.selectaFileWithProperFormat')); //NO I18N
            var browse=$('#importCsv');
            var textfile=document.getElementById('textfile');
            clearfileElt(browse,textfile);
        }
    }
    r.readAsText(f);
    } 
    else { 
        showAlert(I18N.getMsg('js.file.failedToLoadFile'));//NO I18N
    }
}

function loadDeploymentServersFromFile(evt) {
    var f = evt.target.files[0];
    if (f) {
    var r = new FileReader();
    var check=true;
    r.onload = function(e) { 
        var discoverDomains = e.target.result;
        var lines=discoverDomains.split("\n");//No I18N
        var temp="";
        for (var i=0; i < lines.length; i++)
        {
            var line=lines[i].trim();
            temp=temp+line;
            if(i!==lines.length-1)
            {
                temp=temp+"\n";//No I18N
            }
            var words=line.split(",");//No I18N
            if(words.length!=1)
            {
                if(words.length>7 || words.length<4)
                {
                    if(words.length==3 && $("#server_type").val()=="MSStore")
                    {
                        check=true;
                    }
                    else
                    {
                    check=false;
                    break;
                }
            }
        }
        }
        if(check){
            window.FILE_CONTENT=temp;
            $('#discoverDomains').val(discoverDomains);
        }
        else
        {
            showAlert(I18N.getMsg('js.file.selectaFileWithProperFormat')); //NO I18N
            var browse=$('#importCsv');
            var textfile=document.getElementById('textfile');
            clearfileElt(browse,textfile);
        }
    }
    r.readAsText(f);
    } 
    else { 
        showAlert(I18N.getMsg('js.file.failedToLoadFile'));//NO I18N
    }
}
